﻿using System;
using System.Diagnostics;
using com.epson.bank.driver;

namespace TMS_Sample
{
	class CImage_1
	{
		private CProperty_1 m_objProperty = null;

		public CImage_1()
		{
		}

		public ErrorCode Init(CProperty_1 objProperty)
		{
			ErrorCode errResult = ErrorCode.SUCCESS;

			m_objProperty = objProperty;

			return errResult;
		}

		// Specify image data format
		public ErrorCode SetImageSetting(ScanSide eFace, ImageType eLightSource, com.epson.bank.driver.ColorDepth eColorDepth, Format eFormat)
		{
			ErrorCode errResult = ErrorCode.SUCCESS;
			Color eColor = Color.EPS_BI_SCN_COLOR;
			ExOption eExOption = ExOption.EPS_BI_SCN_MANUAL;

			errResult = m_objProperty.GetMfDevice().SCNSelectScanFace(eFace);
			Debug.Assert(errResult == ErrorCode.SUCCESS);
			if (errResult != ErrorCode.SUCCESS)
			{
				return errResult;
			}

			errResult = m_objProperty.GetMfDevice().SCNSelectScanImage(eLightSource);
			Debug.Assert(errResult == ErrorCode.SUCCESS);
			if (errResult != ErrorCode.SUCCESS)
			{
				return errResult;
			}

			if (eColorDepth == ColorDepth.EPS_BI_SCN_24BIT)
			{
				eColor      = Color.EPS_BI_SCN_COLOR;
				eExOption   = ExOption.EPS_BI_SCN_MANUAL;
			}
			else
			{
				eColor      = Color.EPS_BI_SCN_MONOCHROME;
				eExOption   = ExOption.EPS_BI_SCN_SHARP;
			}

			errResult = m_objProperty.GetMfDevice().SCNSetImageQuality(eColorDepth, 0, eColor, eExOption);
			Debug.Assert(errResult == ErrorCode.SUCCESS);
			if (errResult != ErrorCode.SUCCESS)
			{
				return errResult;
			}

			errResult = m_objProperty.GetMfDevice().SCNSetImageFormat(eFormat);
			Debug.Assert(errResult == ErrorCode.SUCCESS);
			if (errResult != ErrorCode.SUCCESS)
			{
				return errResult;
			}

			return errResult;
		}
	}
}
