using System;
using com.epson.bank.driver;

namespace TMS_Sample
{
	public class CIqaParam
	{
		MfErrorSelect m_eIqaDetect;
		ColorDepth m_eColorDepth;
		MfCancel m_eCancel;
		MfEject m_eEjectPocket;
		MfIqaTest m_eUnderSize;
		MfIqaTest m_eOverSize;
		MfIqaTest m_eMinCompressed;
		MfIqaTest m_eMaxCompressed;
		MfIqaTest m_eFrontRearImageMismatch;
		MfIqaTest m_eImageTooLight;
		MfIqaTest m_eImageTooDark;
		MfIqaTest m_eStreaks;
		MfIqaTest m_eSpotNoise;
		MfIqaTest m_eOutOfFocus;
		MfIqaTest m_eFoldedTornCorner;
		MfIqaTest m_eFoldedTornEdge;
		MfIqaTest m_eFramingError;
		MfIqaTest m_eExcessiveSkew;
		MfIqaTest m_eCarbon;
		MfIqaTest m_ePiggyback;

		public CIqaParam()
		{
			m_eIqaDetect = MfErrorSelect.MF_ERROR_SELECT_NODETECT;
			m_eColorDepth = ColorDepth.EPS_BI_SCN_1BIT;
			m_eCancel = MfCancel.MF_CANCEL_DISABLE;
			m_eEjectPocket = MfEject.MF_EJECT_MAIN_POCKET;
			m_eUnderSize = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eOverSize = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eMinCompressed = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eMaxCompressed = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eFrontRearImageMismatch = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eImageTooLight = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eImageTooDark = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eStreaks = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eSpotNoise = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eOutOfFocus = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eFoldedTornCorner = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eFoldedTornEdge = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eExcessiveSkew = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_eCarbon = MfIqaTest.MF_IQA_TEST_DISABLE;
			m_ePiggyback = MfIqaTest.MF_IQA_TEST_DISABLE;
		}

		public void SetIqaDetect(MfErrorSelect eIqaDetect)
		{
			m_eIqaDetect = eIqaDetect;
		}
		public MfErrorSelect GetIqaDetect()
		{
			return m_eIqaDetect;
		}
		public void SetIqaColorDepth(ColorDepth eColorDepth)
		{
			m_eColorDepth = eColorDepth;
		}
		public ColorDepth GetIqaColorDepth()
		{
			return m_eColorDepth;
		}
		public void SetIqaCancel(MfCancel eCancel)
		{
			m_eCancel = eCancel;
		}
		public MfCancel GetIqaCancel()
		{
			return m_eCancel;
		}
		public void SetIqaEjectPocket(MfEject eEjectPocket)
		{
			m_eEjectPocket = eEjectPocket;
		}
		public MfEject GetIqaEjectPocket()
		{
			return m_eEjectPocket;
		}
		public void SetUnderSize(MfIqaTest eUnderSize)
		{
			m_eUnderSize = eUnderSize;
		}
		public MfIqaTest GetUnderSize()
		{
			return m_eUnderSize;
		}
		public void SetOverSize(MfIqaTest eOverSize)
		{
			m_eOverSize = eOverSize;
		}
		public MfIqaTest GetOverSize()
		{
			return m_eOverSize;
		}
		public void SetMinCompressed(MfIqaTest eMinCompressed)
		{
			m_eMinCompressed = eMinCompressed;
		}
		public MfIqaTest GetMinCompressed()
		{
			return m_eMinCompressed;
		}
		public void SetMaxCompressed(MfIqaTest eMaxCompressed)
		{
			m_eMaxCompressed = eMaxCompressed;
		}
		public MfIqaTest GetMaxCompressed()
		{
			return m_eMaxCompressed;
		}
		public void SetFrontRearImageMismatch(MfIqaTest eFrontRearImageMismatch)
		{
			m_eFrontRearImageMismatch = eFrontRearImageMismatch;
		}
		public MfIqaTest GetFrontRearImageMismatch()
		{
			return m_eFrontRearImageMismatch;
		}
		public void SetImageTooLight(MfIqaTest eImageTooLight)
		{
			m_eImageTooLight = eImageTooLight;
		}
		public MfIqaTest GetImageTooLight()
		{
			return m_eImageTooLight;
		}
		public void SetImageTooDark(MfIqaTest eImageTooDark)
		{
			m_eImageTooDark = eImageTooDark;
		}
		public MfIqaTest GetImageTooDark()
		{
			return m_eImageTooDark;
		}
		public void SetHorizontalStreaksPresent(MfIqaTest eStreaks)
		{
			m_eStreaks = eStreaks;
		}
		public MfIqaTest GetHorizontalStreaksPresent()
		{
			return m_eStreaks;
		}
		public void SetSpotNoise(MfIqaTest eSpotNosise)
		{
			m_eSpotNoise = eSpotNosise;
		}
		public MfIqaTest GetSpotNoise()
		{
			return m_eSpotNoise;
		}
		public void SetOutOfFocus(MfIqaTest eOutOfFocus)
		{
			m_eOutOfFocus = eOutOfFocus;
		}
		public MfIqaTest GetOutOfFocus()
		{
			return m_eOutOfFocus;
		}
		public void SetFoldedTornCorner(MfIqaTest eFoldedTornCorner)
		{
			m_eFoldedTornCorner = eFoldedTornCorner;
		}
		public MfIqaTest GetFoldedTornCorner()
		{
			return m_eFoldedTornCorner;
		}
		public void SetFoldedTornEdge(MfIqaTest eFoldedTornEdge)
		{
			m_eFoldedTornEdge = eFoldedTornEdge;
		}
		public MfIqaTest GetFoldedTornEdge()
		{
			return m_eFoldedTornEdge;
		}
		public void SetFramingError(MfIqaTest eFramingError)
		{
			m_eFramingError = eFramingError;
		}
		public MfIqaTest GetFramingError()
		{
			return m_eFramingError;
		}
		public void SetExcessiveSkew(MfIqaTest eExcessiveSkew)
		{
			m_eExcessiveSkew = eExcessiveSkew;
		}
		public MfIqaTest GetExcessiveSkew()
		{
			return m_eExcessiveSkew;
		}
		public void SetCarbonStripDetection(MfIqaTest eCarbonStripDetection)
		{
			m_eCarbon = eCarbonStripDetection;
		}
		public MfIqaTest GetCarbonStripDetection()
		{
			return m_eCarbon;
		}
		public void SetPiggyback(MfIqaTest ePiggyback)
		{
			m_ePiggyback = ePiggyback;
		}
		public MfIqaTest GetPiggyback()
		{
			return m_ePiggyback;
		}
	}
}
