﻿using System;

namespace TMS_Sample
{
	public class StructByStep
	{
		// Step 2
		public int	nRadio_ScanningMedia;
		public int	nRadio_LightSourceToScan;
		public int	nRadio_RGBColorDepth;
		public int	nRadio_IRColorDepth;
		public int	nCombo_Resolution;
		public byte byNumeric_NumberOfDocuments;
		public bool bCheck_Scan_SaveFile;
		public bool bIsScanningCardIR1PassSupported;

		// Step 3
		public int  nRadio_MICRFont;
		public bool bCheck_MICR_ClearSpace;
		public bool bCheck_MICR_SaveFile;

		// Step 7
		public int  nRadio_ActivationMode;
		public bool bCheck_ConfirmationByUser;
		public int nCombo_WaterfallMode;
		// Step 7
		public bool bCheck_IQA_Detect;
		public bool bCheck_IQA_Cancel;
		public int nCombo_IqaEjectPocket;
		public int nCombo_IqaColorDepth;
		public bool bCheck_IQA_UnderSize;
		public bool bCheck_IQA_OverSize;
		public bool bCheck_IQA_MinCompressed;
		public bool bCheck_IQA_MaxCompressed;
		public bool bCheck_IQA_FrontRearMismatch;
		public bool bCheck_IQA_TooLight;
		public bool bCheck_IQA_TooDark;
		public bool bCheck_IQA_HorizontalStreaks;
		public bool bCheck_IQA_SpotNoise;
		public bool bCheck_IQA_OutOfFocus;
		public bool bCheck_IQA_DocCorners;
		public bool bCheck_IQA_DocEdges;
		public bool bCheck_IQA_FramingError;
		public bool bCheck_IQA_Skew;
		public bool bCheck_IQA_CarbonStrip;
		public bool bCheck_IQA_Piggyback;

		public StructByStep()
		{
			// Step 2
			nRadio_ScanningMedia      = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
			nRadio_LightSourceToScan  = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB;
			nRadio_RGBColorDepth      = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
			nRadio_IRColorDepth       = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY;
			bCheck_Scan_SaveFile      = ConstComVal.VAL_CONFIGDLG_CHECK_SC_SAVEFILE_ON;
			nCombo_Resolution         = ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200;
			bIsScanningCardIR1PassSupported = false;

			// Step 3
			nRadio_MICRFont           = ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B;
			bCheck_MICR_ClearSpace    = ConstComVal.VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_OFF;
			bCheck_MICR_SaveFile      = ConstComVal.VAL_CONFIGDLG_CHECK_MI_SAVEFILE_OFF;

			// Step 7
			nRadio_ActivationMode = ConstComVal.VAL_CONFIGDLG_RADIO_AM_HIGHSPEED;
			bCheck_ConfirmationByUser = false;
			nCombo_WaterfallMode  = ConstComVal.VAL_CONFIGDLG_COMBO_WM_DISABLE;
			// Step 7
			bCheck_IQA_Detect = false;
			bCheck_IQA_Cancel = false;
			nCombo_IqaEjectPocket = ConstComVal.VAL_CONFIGDLG_COMBO_EP_MAINPOCKET;
			nCombo_IqaColorDepth  = ConstComVal.VAL_CONFIGDLG_COMBO_CD_GRAY;
			bCheck_IQA_UnderSize = false;
			bCheck_IQA_OverSize = false;
			bCheck_IQA_MinCompressed = false;
			bCheck_IQA_MaxCompressed = false;
			bCheck_IQA_FrontRearMismatch = false;
			bCheck_IQA_TooLight = false;
			bCheck_IQA_TooDark = false;
			bCheck_IQA_HorizontalStreaks = false;
			bCheck_IQA_SpotNoise = false;
			bCheck_IQA_OutOfFocus = false;
			bCheck_IQA_DocCorners = false;
			bCheck_IQA_DocEdges = false;
			bCheck_IQA_FramingError = false;
			bCheck_IQA_Skew = false;
			bCheck_IQA_CarbonStrip = false;
			bCheck_IQA_Piggyback = false;
		}

		public void Copy(StructByStep sData)
		{
			// Step 2
			nRadio_ScanningMedia      = sData.nRadio_ScanningMedia;
			nRadio_LightSourceToScan  = sData.nRadio_LightSourceToScan;
			nRadio_RGBColorDepth      = sData.nRadio_RGBColorDepth;
			nRadio_IRColorDepth       = sData.nRadio_IRColorDepth;
			nCombo_Resolution         = sData.nCombo_Resolution;
			byNumeric_NumberOfDocuments = sData.byNumeric_NumberOfDocuments;
			bCheck_Scan_SaveFile      = sData.bCheck_Scan_SaveFile;
			bIsScanningCardIR1PassSupported = sData.bIsScanningCardIR1PassSupported;

			// Step 3
			nRadio_MICRFont           = sData.nRadio_MICRFont;
			bCheck_MICR_ClearSpace    = sData.bCheck_MICR_ClearSpace;
			bCheck_MICR_SaveFile      = sData.bCheck_MICR_SaveFile;

			// Step 7
			nRadio_ActivationMode     = sData.nRadio_ActivationMode;
			bCheck_ConfirmationByUser = sData.bCheck_ConfirmationByUser;
			nCombo_WaterfallMode      = sData.nCombo_WaterfallMode;
			// Step 7
			bCheck_IQA_Detect = sData.bCheck_IQA_Detect;
			bCheck_IQA_Cancel = sData.bCheck_IQA_Cancel;
			nCombo_IqaEjectPocket = sData.nCombo_IqaEjectPocket;
			nCombo_IqaColorDepth			= sData.nCombo_IqaColorDepth;
			bCheck_IQA_UnderSize = sData.bCheck_IQA_UnderSize;
			bCheck_IQA_OverSize = sData.bCheck_IQA_OverSize;
			bCheck_IQA_MinCompressed = sData.bCheck_IQA_MinCompressed;
			bCheck_IQA_MaxCompressed = sData.bCheck_IQA_MaxCompressed;
			bCheck_IQA_FrontRearMismatch = sData.bCheck_IQA_FrontRearMismatch;
			bCheck_IQA_TooLight = sData.bCheck_IQA_TooLight;
			bCheck_IQA_TooDark = sData.bCheck_IQA_TooDark;
			bCheck_IQA_HorizontalStreaks = sData.bCheck_IQA_HorizontalStreaks;
			bCheck_IQA_SpotNoise = sData.bCheck_IQA_SpotNoise;
			bCheck_IQA_OutOfFocus = sData.bCheck_IQA_OutOfFocus;
			bCheck_IQA_DocCorners = sData.bCheck_IQA_DocCorners;
			bCheck_IQA_DocEdges = sData.bCheck_IQA_DocEdges;
			bCheck_IQA_FramingError = sData.bCheck_IQA_FramingError;
			bCheck_IQA_Skew = sData.bCheck_IQA_Skew;
			bCheck_IQA_CarbonStrip = sData.bCheck_IQA_CarbonStrip;
			bCheck_IQA_Piggyback = sData.bCheck_IQA_Piggyback;
		}
	}
	// Step 7
	public class ConfirmationData
	{
		public int nRadio_Confirmation_EjectPocket;
		public bool bCheck_Confirmation_Cancel;

		public ConfirmationData()
		{
			nRadio_Confirmation_EjectPocket = ConstComVal.VAL_CONFIRMATIONDLG_RADIO_EP_MAINPOCKET;
			bCheck_Confirmation_Cancel      = false;
		}

		public void Copy(ConfirmationData sData)
		{
			nRadio_Confirmation_EjectPocket = sData.nRadio_Confirmation_EjectPocket;
			bCheck_Confirmation_Cancel      = sData.bCheck_Confirmation_Cancel;
		}
	}
}
