using System;
using com.epson.bank.driver;

namespace TMS_Sample
{
	public class CMaintenanceCounter
	{
		// uint -> uint 
		int m_nImageScannedCheckPaper;
		int m_nImageScannedCard;
		int m_nLineFeeds;                                 // S9000 only
		int m_nPumpOperation;
		int m_nMicrReads;
		int m_nHeadShotA;
		int m_nHeadShotB;
		int m_nHeadEnergization;                          // S9000 only
		int m_nAsfSendingOff;
		int m_nHeadLineFeeds;                             // S9000 only
		int m_nAutoCutter;                                // S9000 only
		int m_nHopper;
		int m_nPocketSelect;
		int m_nDeviceOperationTime;

		public CMaintenanceCounter()
		{
			m_nImageScannedCheckPaper	= 0;
			m_nImageScannedCard			= 0;
			m_nLineFeeds				= 0; // S9000 only
			m_nPumpOperation			= 0;
			m_nMicrReads				= 0;
			m_nHeadShotA				= 0;
			m_nHeadShotB				= 0;
			m_nHeadEnergization			= 0; // S9000 only
			m_nAsfSendingOff			= 0;
			m_nHeadLineFeeds			= 0; // S9000 only
			m_nAutoCutter				= 0; // S9000 only
			m_nHopper					= 0;
			m_nPocketSelect				= 0;
			m_nDeviceOperationTime		= 0;
		}

		public void SetImageScannedCheckPaper(int nImageScannedCheckPaper)
		{
			m_nImageScannedCheckPaper = nImageScannedCheckPaper;
		}

		public int GetImageScannedCheckPaper()
		{
			return m_nImageScannedCheckPaper;
		}

		public void SetImageScannedCard(int nImageScannedCard)
		{
			m_nImageScannedCard = nImageScannedCard;
		}

		public int GetImageScannedCard()
		{
			return m_nImageScannedCard;
		}

		public void SetLineFeeds(int dwLineFeeds) // S9000 only
		{
			m_nLineFeeds = dwLineFeeds;
		}

		public int GetLineFeeds() // S9000 only
		{
			return m_nLineFeeds;
		}

		public void SetPumpOperation(int nPumpOperation)
		{
			m_nPumpOperation = nPumpOperation;
		}

		public int GetPumpOperation()
		{
			return m_nPumpOperation;
		}

		public void SetMicrReads(int nMicrReads)
		{
			m_nMicrReads = nMicrReads;
		}

		public int GetMicrReads()
		{
			return m_nMicrReads;
		}

		public void SetHeadShotA(int nHeadShotA)
		{
			m_nHeadShotA = nHeadShotA;
		}

		public int GetHeadShotA()
		{
			return m_nHeadShotA;
		}

		public void SetHeadShotB(int nHeadShotB)
		{
			m_nHeadShotB = nHeadShotB;
		}

		public int GetHeadShotB()
		{
			return m_nHeadShotB;
		}

		public void SetHeadEnergization(int nHeadEnergization) // S9000 only
		{
			m_nHeadEnergization = nHeadEnergization;
		}

		public int GetHeadEnergization() // S9000 only
		{
			return m_nHeadEnergization;
		}

		public void SetAsfSendingOff(int nAsfSendingOff)
		{
			m_nAsfSendingOff = nAsfSendingOff;
		}

		public int GetAsfSendingOff()
		{
			return m_nAsfSendingOff;
		}

		public void SetHeadLineFeeds(int nHeadLineFeeds) // S9000 only
		{
			m_nAutoCutter = nHeadLineFeeds;
		}

		public int GetHeadLineFeeds() // S9000 only
		{
			return m_nAutoCutter;
		}

		public void SetAutoCutter(int nAutoCutter) // S9000 only
		{
			m_nAutoCutter = nAutoCutter;
		}

		public int GetAutoCutter() // S9000 only
		{
			return m_nAutoCutter;
		}

		public void SetHopper(int nHopper)
		{
			m_nHopper = nHopper;
		}

		public int GetHopper()
		{
			return m_nHopper;
		}

		public void SetPocketSelect(int nPocketSelect)
		{
			m_nPocketSelect = nPocketSelect;
		}

		public int GetPocketSelect()
		{
			return m_nPocketSelect;
		}

		public void SetDeviceOperationTime(int nDeviceOperationTime)
		{
			m_nDeviceOperationTime = nDeviceOperationTime;
		}

		public int GetDeviceOperationTime()
		{
			return m_nDeviceOperationTime;
		}
	}
}
