﻿using System;

namespace TMS_Sample
{
	public class StructByStep
	{
		// Step 2
		public int	nRadio_ScanningMedia;
		public int	nRadio_LightSourceToScan;
		public int	nRadio_RGBColorDepth;
		public int	nRadio_IRColorDepth;
		public int	nCombo_Resolution;
		public byte byNumeric_NumberOfDocuments;
		public bool bCheck_Scan_SaveFile;
		public bool bIsScanningCardIR1PassSupported;

		// Step 3
		public int	nRadio_MICRFont;
		public bool bCheck_MICR_ClearSpace;
		public bool bCheck_MICR_SaveFile;

		// Step 8
		public bool bCheck_PI_Detect;
		public bool bCheck_PI_Cancel;
		public int  nCombo_PI_EjectPocket;
		public bool bCheck_NO_Detect;
		public bool bCheck_NO_Cancel;
		public int  nCombo_NO_EjectPocket;
		public bool bCheck_DF_Detect;
		public bool bCheck_DF_Cancel;
		public int  nCombo_DF_EjectPocket;
		public bool bCheck_BD_Detect;
		public bool bCheck_BD_Cancel;
		public int  nCombo_BD_EjectPocket;
		public bool bCheck_ND_Detect;
		public bool bCheck_ND_Cancel;
		public int  nCombo_ND_EjectPocket;
		public bool bCheck_BA_Detect;
		public bool bCheck_BA_Cancel;
		public int  nCombo_BA_EjectPocket;

		// Step 8
		public bool bCheck_BT_SymbolCodabar;
		public bool bCheck_BT_SymbolCode128;
		public bool bCheck_BT_SymbolCode39;
		public bool bCheck_BT_SymbolITF;
		public bool bCheck_BT_SymbolEAN;
		public bool bCheck_BT_SymbolUPCA;
		public bool bCheck_BT_SymbolUPCE;

		public StructByStep()
		{
			// Step 2
			nRadio_ScanningMedia      = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
			nRadio_LightSourceToScan  = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB;
			nRadio_RGBColorDepth      = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
			nRadio_IRColorDepth       = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY;
			bCheck_Scan_SaveFile      = ConstComVal.VAL_CONFIGDLG_CHECK_SC_SAVEFILE_ON;
			nCombo_Resolution         = ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200;
			bIsScanningCardIR1PassSupported = false;

			// Step 3
			nRadio_MICRFont           = ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B;
			bCheck_MICR_ClearSpace    = ConstComVal.VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_OFF;
			bCheck_MICR_SaveFile      = ConstComVal.VAL_CONFIGDLG_CHECK_MI_SAVEFILE_OFF;

			// Step 8
			bCheck_PI_Detect      = ConstComVal.VAL_CONFIGDLG_CHECK_PI_DETECT_OFF;
			bCheck_PI_Cancel      = ConstComVal.VAL_CONFIGDLG_CHECK_PI_CANCEL_OFF;
			nCombo_PI_EjectPocket = ConstComVal.VAL_CONFIGDLG_COMBO_PI_EP_MAINPOCKET;
			bCheck_NO_Detect      = ConstComVal.VAL_CONFIGDLG_CHECK_NO_DETECT_OFF;
			bCheck_NO_Cancel      = ConstComVal.VAL_CONFIGDLG_CHECK_NO_CANCEL_OFF;
			nCombo_NO_EjectPocket = ConstComVal.VAL_CONFIGDLG_COMBO_NO_EP_MAINPOCKET;
			bCheck_DF_Detect      = ConstComVal.VAL_CONFIGDLG_CHECK_DF_DETECT_OFF;
			bCheck_DF_Cancel      = ConstComVal.VAL_CONFIGDLG_CHECK_DF_CANCEL_OFF;
			nCombo_DF_EjectPocket = ConstComVal.VAL_CONFIGDLG_COMBO_DF_EP_MAINPOCKET;
			bCheck_BD_Detect      = ConstComVal.VAL_CONFIGDLG_CHECK_BD_DETECT_OFF;
			bCheck_BD_Cancel      = ConstComVal.VAL_CONFIGDLG_CHECK_BD_CANCEL_OFF;
			nCombo_BD_EjectPocket = ConstComVal.VAL_CONFIGDLG_COMBO_BD_EP_MAINPOCKET;
			bCheck_ND_Detect      = ConstComVal.VAL_CONFIGDLG_CHECK_ND_DETECT_OFF;
			bCheck_ND_Cancel      = ConstComVal.VAL_CONFIGDLG_CHECK_ND_CANCEL_OFF;
			nCombo_ND_EjectPocket = ConstComVal.VAL_CONFIGDLG_COMBO_ND_EP_MAINPOCKET;
			bCheck_BA_Detect      = ConstComVal.VAL_CONFIGDLG_CHECK_BA_DETECT_OFF;
			bCheck_BA_Cancel      = ConstComVal.VAL_CONFIGDLG_CHECK_BA_CANCEL_OFF;
			nCombo_BA_EjectPocket = ConstComVal.VAL_CONFIGDLG_COMBO_BA_EP_MAINPOCKET;

			// Step 8
			bCheck_BT_SymbolCodabar = false;
			bCheck_BT_SymbolCode128 = false;
			bCheck_BT_SymbolCode39  = false;
			bCheck_BT_SymbolITF     = false;
			bCheck_BT_SymbolEAN     = false;
			bCheck_BT_SymbolUPCA    = false;
			bCheck_BT_SymbolUPCE    = false;
		}

		public void Copy(StructByStep sData)
		{
			// Step 2
			nRadio_ScanningMedia      = sData.nRadio_ScanningMedia;
			nRadio_LightSourceToScan  = sData.nRadio_LightSourceToScan;
			nRadio_RGBColorDepth      = sData.nRadio_RGBColorDepth;
			nRadio_IRColorDepth       = sData.nRadio_IRColorDepth;
			nCombo_Resolution         = sData.nCombo_Resolution;
			byNumeric_NumberOfDocuments = sData.byNumeric_NumberOfDocuments;
			bCheck_Scan_SaveFile      = sData.bCheck_Scan_SaveFile;
			bIsScanningCardIR1PassSupported = sData.bIsScanningCardIR1PassSupported;

			// Step 3
			nRadio_MICRFont           = sData.nRadio_MICRFont;
			bCheck_MICR_ClearSpace    = sData.bCheck_MICR_ClearSpace;
			bCheck_MICR_SaveFile      = sData.bCheck_MICR_SaveFile;

			// Step 8
			bCheck_PI_Detect			= sData.bCheck_PI_Detect;
			bCheck_PI_Cancel			= sData.bCheck_PI_Cancel;
			nCombo_PI_EjectPocket		= sData.nCombo_PI_EjectPocket;
			bCheck_NO_Detect			= sData.bCheck_NO_Detect;
			bCheck_NO_Cancel			= sData.bCheck_NO_Cancel;
			nCombo_NO_EjectPocket		= sData.nCombo_NO_EjectPocket;
			bCheck_DF_Detect			= sData.bCheck_DF_Detect;
			bCheck_DF_Cancel			= sData.bCheck_DF_Cancel;
			nCombo_DF_EjectPocket		= sData.nCombo_DF_EjectPocket;
			bCheck_BD_Detect			= sData.bCheck_BD_Detect;
			bCheck_BD_Cancel			= sData.bCheck_BD_Cancel;
			nCombo_BD_EjectPocket		= sData.nCombo_BD_EjectPocket;
			bCheck_ND_Detect			= sData.bCheck_ND_Detect;
			bCheck_ND_Cancel			= sData.bCheck_ND_Cancel;
			nCombo_ND_EjectPocket		= sData.nCombo_ND_EjectPocket;
			bCheck_BA_Detect			= sData.bCheck_BA_Detect;
			bCheck_BA_Cancel			= sData.bCheck_BA_Cancel;
			nCombo_BA_EjectPocket		= sData.nCombo_BA_EjectPocket;

			// Step 8
			bCheck_BT_SymbolCodabar		= sData.bCheck_BT_SymbolCodabar;
			bCheck_BT_SymbolCode128		= sData.bCheck_BT_SymbolCode128;
			bCheck_BT_SymbolCode39		= sData.bCheck_BT_SymbolCode39;
			bCheck_BT_SymbolITF			= sData.bCheck_BT_SymbolITF;
			bCheck_BT_SymbolEAN			= sData.bCheck_BT_SymbolEAN;
			bCheck_BT_SymbolUPCA		= sData.bCheck_BT_SymbolUPCA;
			bCheck_BT_SymbolUPCE		= sData.bCheck_BT_SymbolUPCE;
		}
	}
}
