// ConfigureDlg.cpp : Implementation
//

#include "stdafx.h"
#include "Resource.h"
#include "ConfigureDlg.h"


// CConfigureDlg Dialog

IMPLEMENT_DYNAMIC(CConfigureDlg, CDialog)

CConfigureDlg::CConfigureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigureDlg::IDD, pParent)
{
}

CConfigureDlg::~CConfigureDlg(void)
{
}

void CConfigureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	// Step 2
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_GROUP_SCANNING, m_stGroupScanning);
	DDX_Control(pDX, IDC_GROUP_SCANNINGMEDIA, m_stGroupScanningMedia);
	DDX_Control(pDX, IDC_GROUP_LIGHTSOURCE, m_stGroupLightSource);
	DDX_Control(pDX, IDC_GROUP_RGBCOLORDEPTH, m_stGroupRGBColorDepth);
	DDX_Control(pDX, IDC_GROUP_IRCOLORDEPTH, m_stGroupIRColorDepth);
	DDX_Control(pDX, IDC_STATIC_RESOLUTION, m_stResolution);
	DDX_Control(pDX, IDC_COMBO_RESOLUTION, m_cmbResolution);
	DDX_Control(pDX, IDC_RADIO_SM_CHECKPAPER, m_btnRadioSMCheckPaper);
	DDX_Control(pDX, IDC_RADIO_SM_CARD, m_btnRadioSMCard);
	DDX_Control(pDX, IDC_RADIO_IC_RGB, m_btnRadioICRGB);
	DDX_Control(pDX, IDC_RADIO_IC_IR, m_btnRadioICIR);
	DDX_Control(pDX, IDC_RADIO_IC_RGBIR, m_btnRadioICRGBIR);
	DDX_Control(pDX, IDC_RADIO_RGBCD_COLOR, m_btnRadioCDRColor);
	DDX_Control(pDX, IDC_RADIO_RGBCD_GRAY, m_btnRadioCDRGray);
	DDX_Control(pDX, IDC_RADIO_RGBCD_BW, m_btnRadioCDRBW);
	DDX_Control(pDX, IDC_RADIO_IRCD_GRAY, m_btnRadioCDIGray);
	DDX_Control(pDX, IDC_RADIO_IRCD_BW, m_btnRadioCDIBW);
	DDX_Control(pDX, IDC_EDIT_SC_NUMBEROFDOCUMENTS, m_edtEditNumberOfDocuments);
	DDX_Control(pDX, IDC_SPIN_SC_NUMBEROFDOCUMENTS, m_spnSpinNumberOfDocuments);
	DDX_Control(pDX, IDC_CHECK_SC_SAVEFILE, m_btnCheckSCSaveFile);
	// Step 3
	DDX_Control(pDX, IDC_GROUP_MICR, m_stGroupMICR);
	DDX_Control(pDX, IDC_GROUP_MICRFONT, m_stGroupMICRFont);
	DDX_Control(pDX, IDC_RADIO_MF_E13B, m_btnRadioMFE13B);
	DDX_Control(pDX, IDC_RADIO_MF_CMC7, m_btnRadioMFCMC7);
	DDX_Control(pDX, IDC_CHECK_MI_CLEARSPACE, m_btnCheckMIClearSpace);
	DDX_Control(pDX, IDC_CHECK_MI_SAVEFILE, m_btnCheckMISaveFile);
	// Step 5
	DDX_Control(pDX, IDC_GROUP_PRINTING, m_stGroupPrinting);
	DDX_Control(pDX, IDC_STATIC_PRINTSTATION, m_stPrintStation);
	DDX_Control(pDX, IDC_STATIC_PRINTINGNUMBER, m_stPrintingNumber);
	DDX_Control(pDX, IDC_COMBO_PRINTSTATION, m_cmbPrintStation);
	DDX_Control(pDX, IDC_EDIT_PRINTINGNUMBER, m_edtPrintingNumber);
	DDX_Control(pDX, IDC_SPIN_PRINTINGNUMBER, m_btnSpinPrintingNumber);
	DDX_Control(pDX, IDC_CHECK_PRINTSCANNING, m_btnCheckScanning);
}

BEGIN_MESSAGE_MAP(CConfigureDlg, CDialog)
	// Step 2
	ON_BN_CLICKED(IDOK, &CConfigureDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CConfigureDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_RADIO_SM_CHECKPAPER, &CConfigureDlg::OnChangeRadioScanningMedia)
	ON_BN_CLICKED(IDC_RADIO_SM_CARD,       &CConfigureDlg::OnChangeRadioScanningMedia)
	ON_BN_CLICKED(IDC_RADIO_IC_RGB,   &CConfigureDlg::OnChangeRadioLightSource)
	ON_BN_CLICKED(IDC_RADIO_IC_IR,    &CConfigureDlg::OnChangeRadioLightSource)
	ON_BN_CLICKED(IDC_RADIO_IC_RGBIR, &CConfigureDlg::OnChangeRadioLightSource)
	// Step 5
	ON_CBN_SELCHANGE(IDC_COMBO_PRINTSTATION, &CConfigureDlg::OnChangeComboPrintStation)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////
// CConfigureDlg message handlers
/////////////////////////////////////////////////////////////////

BOOL CConfigureDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();

	LoadResourceString();

	SetControlData();

	UpdateControls();

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CConfigureDlg::SetConfigData( CONFIGDATA sConfigData )
{
	m_sConfigData.Copy( sConfigData );
}

void CConfigureDlg::GetConfigData( LPCONFIGDATA psConfigData )
{
	if( psConfigData != NULL )
	{
		psConfigData->Copy( m_sConfigData );
	}
}

void CConfigureDlg::LoadResourceString(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	m_btnOK.SetWindowText( STR_CONFIGDLG_BUTTON_OK );
	m_btnCancel.SetWindowText( STR_CONFIGDLG_BUTTON_CANCEL );

	m_stGroupScanning.SetWindowText( STR_CONFIGDLG_GROUP_SCANNING );
	m_stGroupScanningMedia.SetWindowText( STR_CONFIGDLG_GROUP_SCANNINGMEDIA );
	m_stGroupLightSource.SetWindowText( STR_CONFIGDLG_GROUP_LIGHTSOURCE );
	m_stGroupRGBColorDepth.SetWindowText( STR_CONFIGDLG_GROUP_RGBCOLORDEPTH );
	m_stGroupIRColorDepth.SetWindowText( STR_CONFIGDLG_GROUP_IRCOLORDEPTH );

	m_stResolution.SetWindowText( STR_CONFIGDLG_STATIC_RESOLUTION );

	m_btnRadioSMCheckPaper.SetWindowText( STR_CONFIGDLG_RADIO_SM_CHECKPAPER );
	m_btnRadioSMCard.SetWindowText( STR_CONFIGDLG_RADIO_SM_CARD );
	m_btnRadioICRGB.SetWindowText( STR_CONFIGDLG_RADIO_IC_RGB );
	m_btnRadioICIR.SetWindowText( STR_CONFIGDLG_RADIO_IC_IR );
	m_btnRadioICRGBIR.SetWindowText( STR_CONFIGDLG_RADIO_IC_RGBIR );
	m_btnRadioCDRColor.SetWindowText( STR_CONFIGDLG_RADIO_RGBCD_COLOR );
	m_btnRadioCDRGray.SetWindowText( STR_CONFIGDLG_RADIO_RGBCD_GRAY );
	m_btnRadioCDRBW.SetWindowText( STR_CONFIGDLG_RADIO_RGBCD_BW );
	m_btnRadioCDIGray.SetWindowText( STR_CONFIGDLG_RADIO_IRCD_GRAY );
	m_btnRadioCDIBW.SetWindowText( STR_CONFIGDLG_RADIO_IRCD_BW );
	m_btnCheckSCSaveFile.SetWindowText( STR_CONFIGDLG_CHECK_SC_SAVEFILE );

	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_600600 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_300300 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_240240 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_200200 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_120120 );
	m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_100100 );

	////////////////
	//// Step 3 ////
	////////////////

	m_stGroupMICR.SetWindowText( STR_CONFIGDLG_GROUP_MICR );
	m_stGroupMICRFont.SetWindowText( STR_CONFIGDLG_GROUP_MICRFONT );

	m_btnRadioMFE13B.SetWindowText( STR_CONFIGDLG_RADIO_MF_E13B );
	m_btnRadioMFCMC7.SetWindowText( STR_CONFIGDLG_RADIO_MF_CMC7 );

	m_btnCheckMIClearSpace.SetWindowText( STR_CONFIGDLG_CHECK_MI_CLEARSPACE );
	m_btnCheckMISaveFile.SetWindowText( STR_CONFIGDLG_CHECK_MI_SAVEFILE );

	////////////////
	//// Step 5 ////
	////////////////

	m_stGroupPrinting.SetWindowText( STR_CONFIGDLG_GROUP_PRINT );
	m_stPrintStation.SetWindowText( STR_CONFIGDLG_STATIC_PRINTSTATION );
	m_stPrintingNumber.SetWindowText( STR_CONFIGDLG_STATIC_PRINTNUMBER );
	m_btnCheckScanning.SetWindowText( STR_CONFIGDLG_CHECK_PR_SCANNING );

	m_cmbPrintStation.AddString( STR_CONFIGDLG_COMBO_PS_PRINTRECEIPT );
	m_cmbPrintStation.AddString( STR_CONFIGDLG_COMBO_PS_PRINTCASHERSCHECK );
	// S9000 only
	if ( m_sConfigData.bIsRollPaperSupported )
	{
		m_cmbPrintStation.AddString( STR_CONFIGDLG_COMBO_PS_PRINTROLLPAPER );
	}
}

void CConfigureDlg::SetControlData(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	switch( m_sConfigData.nRadio_ScanningMedia )
	{
		case VAL_CONFIGDLG_RADIO_SM_CHECKPAPER:
			m_btnRadioSMCheckPaper.SetCheck(1);
			m_btnRadioSMCard.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_SM_CARD:
			m_btnRadioSMCheckPaper.SetCheck(0);
			m_btnRadioSMCard.SetCheck(1);
			break;
		default:
			break;
	}
	switch( m_sConfigData.nRadio_LightSourceToScan )
	{
		case VAL_CONFIGDLG_RADIO_IC_RGB:
			m_btnRadioICRGB.SetCheck(1);
			m_btnRadioICIR.SetCheck(0);
			m_btnRadioICRGBIR.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_IC_IR:
			m_btnRadioICRGB.SetCheck(0);
			m_btnRadioICIR.SetCheck(1);
			m_btnRadioICRGBIR.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_IC_RGBIR:
			m_btnRadioICRGB.SetCheck(0);
			m_btnRadioICIR.SetCheck(0);
			m_btnRadioICRGBIR.SetCheck(1);
			break;
		default:
			break;
	}
	switch( m_sConfigData.nRadio_RGBColorDepth )
	{
		case VAL_CONFIGDLG_RADIO_RGBCD_COLOR:
			m_btnRadioCDRColor.SetCheck(1);
			m_btnRadioCDRGray.SetCheck(0);
			m_btnRadioCDRBW.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_RGBCD_GRAY:
			m_btnRadioCDRColor.SetCheck(0);
			m_btnRadioCDRGray.SetCheck(1);
			m_btnRadioCDRBW.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_RGBCD_BW:
			m_btnRadioCDRColor.SetCheck(0);
			m_btnRadioCDRGray.SetCheck(0);
			m_btnRadioCDRBW.SetCheck(1);
			break;
		default:
			break;
	}
	switch( m_sConfigData.nRadio_IRColorDepth )
	{
		case VAL_CONFIGDLG_RADIO_IRCD_GRAY:
			m_btnRadioCDIGray.SetCheck(1);
			m_btnRadioCDIBW.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_IRCD_BW:
			m_btnRadioCDIGray.SetCheck(0);
			m_btnRadioCDIBW.SetCheck(1);
			break;
		default:
			break;
	}

	m_cmbResolution.SetCurSel( m_sConfigData.nCombo_Resolution );

	CString strTmp;
	strTmp.Format( _T("%d"), m_sConfigData.nEdit_NumberOfDocuments );
	m_edtEditNumberOfDocuments.SetWindowText( strTmp );
	m_spnSpinNumberOfDocuments.SetRange32(0, 255);
	m_spnSpinNumberOfDocuments.SetPos32( m_sConfigData.nEdit_NumberOfDocuments );

	m_btnCheckSCSaveFile.SetCheck( m_sConfigData.nCheck_Scan_SaveFile );

	////////////////
	//// Step 3 ////
	////////////////

	switch( m_sConfigData.nRadio_MICRFont )
	{
		case VAL_CONFIGDLG_RADIO_MF_E13B:
			m_btnRadioMFE13B.SetCheck(1);
			m_btnRadioMFCMC7.SetCheck(0);
			break;
		case VAL_CONFIGDLG_RADIO_MF_CMC7:
			m_btnRadioMFE13B.SetCheck(0);
			m_btnRadioMFCMC7.SetCheck(1);
			break;
		default:
			break;
	}

	m_btnCheckMIClearSpace.SetCheck( m_sConfigData.nCheck_MICR_ClearSpace );
	m_btnCheckMISaveFile.SetCheck  ( m_sConfigData.nCheck_MICR_SaveFile );

	////////////////
	//// Step 5 ////
	////////////////

	m_cmbPrintStation.SetCurSel( m_sConfigData.nCombo_PrintStation );
	m_btnCheckScanning.SetCheck( m_sConfigData.nCheck_Print_Scanning );
	m_edtPrintingNumber.SetWindowTextA( m_sConfigData.strEdit_Ptinting_Number );
	m_btnSpinPrintingNumber.SetRange32(0, 255);
}

void CConfigureDlg::GetControlData(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	if( m_btnRadioSMCheckPaper.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_ScanningMedia = VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
	}
	else if( m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_ScanningMedia = VAL_CONFIGDLG_RADIO_SM_CARD;
	}
	else
	{
		ASSERT(FALSE);
	}

	if( m_btnRadioICRGB.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_LightSourceToScan = VAL_CONFIGDLG_RADIO_IC_RGB;
	}
	else if( m_btnRadioICIR.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_LightSourceToScan = VAL_CONFIGDLG_RADIO_IC_IR;
	}
	else if( m_btnRadioICRGBIR.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_LightSourceToScan = VAL_CONFIGDLG_RADIO_IC_RGBIR;
	}
	else
	{
		ASSERT(FALSE);
	}

	if( m_btnRadioCDRColor.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
	}
	else if( m_btnRadioCDRGray.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_GRAY;
	}
	else if( m_btnRadioCDRBW.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_BW;
	}
	else
	{
		ASSERT(FALSE);
	}

	if( m_btnRadioCDIGray.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_IRColorDepth = VAL_CONFIGDLG_RADIO_IRCD_GRAY;
	}
	else if( m_btnRadioCDIBW.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_IRColorDepth = VAL_CONFIGDLG_RADIO_IRCD_BW;
	}
	else
	{
		ASSERT(FALSE);
	}

	m_sConfigData.nCombo_Resolution = GetValueResolutionCombobox();

	m_sConfigData.nEdit_NumberOfDocuments = m_spnSpinNumberOfDocuments.GetPos32();

	m_sConfigData.nCheck_Scan_SaveFile = m_btnCheckSCSaveFile.GetCheck();

	////////////////
	//// Step 3 ////
	////////////////

	if( m_btnRadioMFE13B.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_MICRFont = VAL_CONFIGDLG_RADIO_MF_E13B;
	}
	else if( m_btnRadioMFCMC7.GetCheck() == 1 )
	{
		m_sConfigData.nRadio_MICRFont = VAL_CONFIGDLG_RADIO_MF_CMC7;
	}
	else
	{
		ASSERT(FALSE);
	}

	m_sConfigData.nCheck_MICR_ClearSpace = m_btnCheckMIClearSpace.GetCheck();
	m_sConfigData.nCheck_MICR_SaveFile   = m_btnCheckMISaveFile.GetCheck();

	////////////////
	//// Step 5 ////
	////////////////

	CString strPrintingNumber;
	m_edtPrintingNumber.GetWindowTextA(strPrintingNumber);

	m_sConfigData.nCombo_PrintStation = GetValuePrintStationCombobox();
	m_sConfigData.nCheck_Print_Scanning = m_btnCheckScanning.GetCheck();
	m_sConfigData.strEdit_Ptinting_Number = strPrintingNumber;
}

void CConfigureDlg::UpdateControls(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	// LightSource
	if( m_btnRadioSMCard.GetCheck() == 1 &&
		m_sConfigData.bIsScanningCardIR1PassSupported == FALSE )
	{
		m_btnRadioICRGBIR.EnableWindow( FALSE );
		
		if(m_btnRadioICRGBIR.GetCheck() == 1)
		{
			m_btnRadioICIR.SetCheck(1);
			m_btnRadioICRGBIR.SetCheck(0);
		}
	}
	else
	{
		m_btnRadioICRGBIR.EnableWindow( TRUE );
	}

	// RGB ColorDepth Color
	if( m_btnRadioICIR.GetCheck() == 1 )
	{
		m_btnRadioCDRColor.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDRColor.EnableWindow( TRUE );
	}

	// RGB ColorDepth Gray
	if( m_btnRadioICIR.GetCheck() == 1 )
	{
		m_btnRadioCDRGray.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDRGray.EnableWindow( TRUE );
	}

	// RGB ColorDepth B/W
	if( m_btnRadioICIR.GetCheck() == 1 || m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_btnRadioCDRBW.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDRBW.EnableWindow( TRUE );
	}

	// IR ColorDepth Gray
	if( m_btnRadioICRGB.GetCheck() == 1 )
	{
		m_btnRadioCDIGray.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDIGray.EnableWindow( TRUE );
	}

	// IR ColorDepth B/W
	if( m_btnRadioICRGB.GetCheck() == 1 || m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_btnRadioCDIBW.EnableWindow( FALSE );
	}
	else
	{
		m_btnRadioCDIBW.EnableWindow( TRUE );
	}

	if( m_btnRadioCDRBW.GetCheck() == 1 && m_btnRadioCDRGray.IsWindowEnabled() && !m_btnRadioCDRBW.IsWindowEnabled() )
	{
		m_btnRadioCDRColor.SetCheck(0);
		m_btnRadioCDRGray.SetCheck(1);
		m_btnRadioCDRBW.SetCheck(0);
	}
	if( m_btnRadioCDIBW.GetCheck() == 1 && m_btnRadioCDIGray.IsWindowEnabled() && !m_btnRadioCDIBW.IsWindowEnabled() )
	{
		m_btnRadioCDIGray.SetCheck(1);
		m_btnRadioCDIBW.SetCheck(0);
	}

	// Updating resolution options for scanning unit
	CString strResolution;
	m_cmbResolution.GetLBText(m_cmbResolution.GetCurSel(), strResolution);
	if( m_btnRadioSMCheckPaper.GetCheck() == 1 )
	{
		m_cmbResolution.ResetContent();
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_300300 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_240240 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_200200 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_120120 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_100100 );
		m_cmbResolution.SetCurSel(2);
	}
	else if( m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_cmbResolution.ResetContent();
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_600600 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_300300 );
		m_cmbResolution.AddString( STR_CONFIGDLG_COMBO_RE_200200 );
		m_cmbResolution.SetCurSel(1);
	}
	else
	{
		ASSERT(FALSE);
	}
	// restore the selection.
	int nIndex = m_cmbResolution.FindString(-1, strResolution);
	if (nIndex != CB_ERR)
	{
		m_cmbResolution.SetCurSel(nIndex);
	}

	////////////////
	//// Step 3 ////
	////////////////

	if( m_btnRadioSMCard.GetCheck() == 1 )
	{
		m_btnRadioMFE13B.EnableWindow( false );
		m_btnRadioMFCMC7.EnableWindow( false );
		m_btnCheckMIClearSpace.EnableWindow( false );
		m_btnCheckMISaveFile.EnableWindow( false );
	}
	else if( m_btnRadioSMCheckPaper.GetCheck() == 1 )
	{
		m_btnRadioMFE13B.EnableWindow( true );
		m_btnRadioMFCMC7.EnableWindow( true );
		m_btnCheckMIClearSpace.EnableWindow( true );
		m_btnCheckMISaveFile.EnableWindow( true );
	}
	else
	{
		ASSERT(FALSE);
	}

	////////////////
	//// Step 5 ////
	////////////////

	int nPrintStation;
	nPrintStation = GetValuePrintStationCombobox();

	// Printing Number Checkbox
	if( nPrintStation == VAL_CONFIGDLG_COMBO_PS_PRINTCASHERSCHECK )
	{
		m_edtPrintingNumber.EnableWindow( true );
		m_btnSpinPrintingNumber.EnableWindow( true );
	}
	else
	{
		m_edtPrintingNumber.EnableWindow( false );
		m_btnSpinPrintingNumber.EnableWindow( false );
	}

	// Scanning Checkbox
	if( nPrintStation == VAL_CONFIGDLG_COMBO_PS_PRINTCASHERSCHECK )
	{
		m_btnCheckScanning.EnableWindow( true );
	}
	else
	{
		m_btnCheckScanning.EnableWindow( false );
	}
}

////////////////
//// Step 2 ////
////////////////

void CConfigureDlg::OnBnClickedOk(void)
{
	GetControlData();
	OnOK();
}

void CConfigureDlg::OnBnClickedCancel(void)
{
	OnCancel();
}

void CConfigureDlg::OnChangeRadioScanningMedia(void)
{
	UpdateControls();
}

void CConfigureDlg::OnChangeRadioLightSource(void)
{
	UpdateControls();
}

////////////////
//// Step 5 ////
////////////////

void CConfigureDlg::OnChangeComboPrintStation(void)
{
	UpdateControls();
}

////////////////
//// Step 2 ////
////////////////

void CConfigureDlg::SetIndexResolutionCombobox( int nResolution )
{
	CString strResolution;
	switch (nResolution)
	{
		case VAL_CONFIGDLG_COMBO_RE_600600: strResolution = STR_CONFIGDLG_COMBO_RE_600600; break;
		case VAL_CONFIGDLG_COMBO_RE_300300: strResolution = STR_CONFIGDLG_COMBO_RE_300300; break;
		case VAL_CONFIGDLG_COMBO_RE_240240: strResolution = STR_CONFIGDLG_COMBO_RE_240240; break;
		case VAL_CONFIGDLG_COMBO_RE_200200: strResolution = STR_CONFIGDLG_COMBO_RE_200200; break;
		case VAL_CONFIGDLG_COMBO_RE_120120: strResolution = STR_CONFIGDLG_COMBO_RE_120120; break;
		case VAL_CONFIGDLG_COMBO_RE_100100: strResolution = STR_CONFIGDLG_COMBO_RE_100100; break;
		default:
			ASSERT(FALSE);
			return;
	}
	int nIndex = m_cmbResolution.FindString(-1, strResolution);
	if (nIndex != CB_ERR)
	{
		m_cmbResolution.SetCurSel(nIndex);
	}
	else
	{
		m_cmbResolution.SetCurSel(0);
	}
	return;
}

int CConfigureDlg::GetValueResolutionCombobox(void)
{
	CString strResolution;
	m_cmbResolution.GetLBText( m_cmbResolution.GetCurSel(), strResolution );

	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_600600 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_600600;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_300300 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_300300;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_240240 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_240240;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_200200 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_200200;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_120120 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_120120;
	}
	if( strResolution.CompareNoCase( STR_CONFIGDLG_COMBO_RE_100100 ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_RE_100100;
	}

	return -1;
}

////////////////
//// Step 5 ////
////////////////

int CConfigureDlg::GetValuePrintStationCombobox(void)
{
	CString strPrintStation;
	m_cmbPrintStation.GetLBText( m_cmbPrintStation.GetCurSel(), strPrintStation );

	if( strPrintStation.CompareNoCase( STR_CONFIGDLG_COMBO_PS_PRINTRECEIPT ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_PS_PRINTRECEIPT;
	}
	if( strPrintStation.CompareNoCase( STR_CONFIGDLG_COMBO_PS_PRINTCASHERSCHECK ) == 0 )
	{
		return VAL_CONFIGDLG_COMBO_PS_PRINTCASHERSCHECK;
	}
	if( strPrintStation.CompareNoCase( STR_CONFIGDLG_COMBO_PS_PRINTROLLPAPER ) == 0 )
	{
		// S9000 only
		return VAL_CONFIGDLG_COMBO_PS_PRINTROLLPAPER;
	}

	return -1;
}
