#pragma once
#include "afxwin.h"


// CConfigureDlg Dialog

class CConfigureDlg : public CDialog
{
	DECLARE_DYNAMIC(CConfigureDlg)

public:
	CConfigureDlg(CWnd* pParent = NULL);   // Standard constructor
	virtual ~CConfigureDlg(void);

	// Dialog resouce ID
	enum { IDD = IDD_DIALOG_CONFIG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Support

public:
	DECLARE_MESSAGE_MAP()
	virtual BOOL OnInitDialog(void);
	// Step 2
	afx_msg void OnBnClickedOk(void);
	afx_msg void OnBnClickedCancel(void);
	afx_msg void OnChangeRadioScanningMedia(void);
	afx_msg void OnChangeRadioLightSource(void);
	// Step 5
	afx_msg void OnChangeComboPrintStation(void);

// Control
protected:
	// Step 2
	CButton			m_btnOK;
	CButton			m_btnCancel;

	CStatic			m_stGroupScanning;
	CStatic			m_stGroupScanningMedia;
	CStatic			m_stGroupLightSource;
	CStatic			m_stGroupRGBColorDepth;
	CStatic			m_stGroupIRColorDepth;

	CStatic			m_stResolution;
	CComboBox		m_cmbResolution;

	CButton			m_btnRadioSMCheckPaper;
	CButton			m_btnRadioSMCard;
	CButton			m_btnRadioICRGB;
	CButton			m_btnRadioICIR;
	CButton			m_btnRadioICRGBIR;
	CButton			m_btnRadioCDRColor;
	CButton			m_btnRadioCDRGray;
	CButton			m_btnRadioCDRBW;
	CButton			m_btnRadioCDIGray;
	CButton			m_btnRadioCDIBW;

	CEdit			m_edtEditNumberOfDocuments;
	CSpinButtonCtrl	m_spnSpinNumberOfDocuments;

	CButton			m_btnCheckSCSaveFile;

	// Step 3
	CStatic			m_stGroupMICR;
	CStatic			m_stGroupMICRFont;

	CButton			m_btnRadioMFE13B;
	CButton			m_btnRadioMFCMC7;

	CButton			m_btnCheckMIClearSpace;
	CButton			m_btnCheckMISaveFile;

	// Step 5
	CStatic			m_stGroupPrinting;
	CStatic			m_stPrintStation;
	CStatic			m_stPrintingNumber;

	CComboBox		m_cmbPrintStation;
	CEdit			m_edtPrintingNumber;
	CSpinButtonCtrl	m_btnSpinPrintingNumber;
	CButton			m_btnCheckScanning;

// Function
public:
	// Step 2
	void SetConfigData( CONFIGDATA sConfigData );
	void GetConfigData( LPCONFIGDATA psConfigData );

protected:
	// Step 2
	void LoadResourceString(void);
	void SetControlData(void);
	void GetControlData(void);
	void UpdateControls(void);
	void SetIndexResolutionCombobox( int nResolution );
	int  GetValueResolutionCombobox(void);
	// Step 5
	int GetValuePrintStationCombobox(void);

// Value
private:
	// Step 2
	CONFIGDATA	m_sConfigData;
};
