#include "stdafx.h"
#include "Print.h"
#include <shlwapi.h>

CPrint::CPrint(void)
{
	m_pCProperty = NULL;
}

CPrint::~CPrint(void)
{
}

int CPrint::Init(CProperty_1* pProperty)
{
	int nResult = SUCCESS;

	m_pCProperty = pProperty;

	GetAPIProcAddress();

	return nResult;
}

// Print on roll paper
int CPrint::PrintRollpaper(void)
{
	// S9000 only
	int nResult = SUCCESS;
	
	// Set printing unit to roll paper
	nResult = BiSetPrintStation(m_pCProperty->GetHandle(), MF_ST_ROLLPAPER);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Start print data buffering
	nResult = BiBufferedPrint(m_pCProperty->GetHandle(), MF_PRT_BUFFERING);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set image data for printing
	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_CENTER);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSetPrintSize(m_pCProperty->GetHandle(), 65, 15);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Compose path, API Driver supports only MBCS.
	char szPath[_MAX_PATH] = {0};
	(void)::GetModuleFileNameA (NULL, szPath, _countof(szPath));
	(void)::PathRemoveFileSpecA(szPath);
	(void)::PathAppendA        (szPath, "Logo.bmp");

	nResult = BiPrintImage(m_pCProperty->GetHandle(), szPath);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set printing text
	char *pcRollPaperString = NULL;
	CString strRollPaperString;
	CString strAddString;
	SYSTEMTIME stSystemTime;

	MF_DECORATE tDecorate;
	tDecorate.dwAttribute	= MF_PRINT_NO_ATTRIBUTE;
	tDecorate.wFont			= MF_PRINT_FONT_B;
	tDecorate.szFontName	= NULL;
	tDecorate.wFontSize		= MF_PRINT_FONT_W1_H1;

	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_RIGHT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	strAddString.Format( _T("\n\n600 Grant Street Pittsburgh, PA 15219\n") );
	strRollPaperString += strAddString;

	strAddString.Format( _T("Phone: (555)555-5555\n\n\n") );
	strRollPaperString += strAddString;

	pcRollPaperString = new char[strRollPaperString.GetLength() + 1];
	strcpy_s( pcRollPaperString, strRollPaperString.GetLength() + 1, strRollPaperString );

	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	delete[] pcRollPaperString;
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	tDecorate.wFont = MF_PRINT_FONT_A;
	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_LEFT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	GetSystemTime(&stSystemTime);

	strAddString.Format(_T("Station S1             Teller 0001 Seq# 02\n") );
	strRollPaperString = strAddString;

	strAddString.Format( _T("%02d/%02d/%02d                        %02d:%02d:%02d\n\n"),
		stSystemTime.wDay, stSystemTime.wMonth,stSystemTime.wYear,
		stSystemTime.wHour, stSystemTime.wMinute, stSystemTime.wSecond );
	strRollPaperString += strAddString;

	pcRollPaperString = new char[strRollPaperString.GetLength() + 1];
	strcpy_s( pcRollPaperString, strRollPaperString.GetLength() + 1, strRollPaperString );

	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	delete[] pcRollPaperString;
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_CENTER);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pcRollPaperString = "Deposit Transaction Receipt\n\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_LEFT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	tDecorate.dwAttribute = MF_PRINT_UNDERLINE_1;
	pcRollPaperString = "Deposit Ticket                   Amount($)\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	tDecorate.dwAttribute = MF_PRINT_NO_ATTRIBUTE;
	pcRollPaperString = "Account #1234567890               1,000.00\n\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	tDecorate.dwAttribute = MF_PRINT_UNDERLINE_1;
	pcRollPaperString = "Demosited Items                  Amount($)\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	tDecorate.dwAttribute = MF_PRINT_NO_ATTRIBUTE;
	pcRollPaperString = "Personal Check\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pcRollPaperString = "1234567890-1541                   1,000.00\n\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_RIGHT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pcRollPaperString = "---------\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_LEFT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pcRollPaperString = "Total:                            1,000.0\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_CENTER);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pcRollPaperString = "Successful Deposit Transaction.\n\n";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pcRollPaperString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set printing barcode
	nResult = BiSetPrintAlignment(m_pCProperty->GetHandle(), MF_PRINT_ALIGNMENT_CENTER);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSetPrintSize(m_pCProperty->GetHandle(), 30, 15);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	BYTE pLinearBarcode[] = "123456789";
	nResult = BiPrintBarCode(m_pCProperty->GetHandle(),	pLinearBarcode, (DWORD)sizeof(pLinearBarcode)-1, CODE_CODE39, HRI_BELOW);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}
	
	BYTE p2DBarcode[] = "EXCEED YOUR VISION EXCEED YOUR VISION EXCEED YOUR VISION EXCEED YOUR VISION EXCEED YOUR VISION";
	nResult = BiPrintBarCode(m_pCProperty->GetHandle(),	p2DBarcode, (DWORD)sizeof(p2DBarcode)-1, CODE_PDF417, HRI_NONE);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Auto Cutter
	nResult = BiAutoCutRollPaper(m_pCProperty->GetHandle(), AUTOCUT_FEEDANDCUT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// print buffered printing data
	nResult = BiBufferedPrint(m_pCProperty->GetHandle(), MF_PRT_EXEC);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	return nResult;
}

// Print on cut sheet paper
int CPrint::PrintReceipt(void)
{
	int nResult = SUCCESS;

	// Set printing unit to cut sheet paper
	nResult = BiSetPrintStation(m_pCProperty->GetHandle(), MF_ST_FEEDER);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Compose path, API Driver supports only MBCS.
	char szPath[_MAX_PATH] = {0};
	(void)::GetModuleFileNameA (NULL, szPath, _countof(szPath));
	(void)::PathRemoveFileSpecA(szPath);
	(void)::PathAppendA        (szPath, "FormatSettingStep5.ini");

	// Load print information file for template printing
	int nLoadNum = 0;
	nResult = BiLoadTemplatePrintArea(m_pCProperty->GetHandle(), szPath, &nLoadNum);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSetPrintCutSheetSettings(m_pCProperty->GetHandle(), 1, BI_PRINTCUTSHEET_NOSCAN);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), m_pCProperty->GetMfBase01(), MF_GET_BASE_DEFAULT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	m_pCProperty->GetMfBase01()->iSize = sizeof(MF_BASE01);
	m_pCProperty->GetMfBase01()->iVersion = MF_BASE_VERSION01;

	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), m_pCProperty->GetMfBase01(), MF_SET_BASE_PARAM);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}
	
	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), NULL, MF_EXEC);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	return nResult;
}

// Set contents of cut sheet paper printing
int CPrint::PrintReceiptFunction(unsigned long ulTransactionNumber)
{
	int nResult = SUCCESS;

	// Start buffering of print data for template printing
	nResult = BiTemplatePrint(m_pCProperty->GetHandle(), TEMPLATEPRINT_BUFFERING);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set image data for printing
	nResult = BiSetTemplatePrintArea(m_pCProperty->GetHandle(), SELECTPRINTAREA_AREANAME, "ReceiptLogo", NULL, TRANS_NO_SPECIFIED);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Compose path, API Driver supports only MBCS.
	char szPath[_MAX_PATH] = {0};
	(void)::GetModuleFileNameA (NULL, szPath, _countof(szPath));
	(void)::PathRemoveFileSpecA(szPath);
	(void)::PathAppendA        (szPath, "ReceiptImage.bmp");

	nResult = BiPrintImage(m_pCProperty->GetHandle(), szPath);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set print text
	nResult = BiSetTemplatePrintArea(m_pCProperty->GetHandle(), SELECTPRINTAREA_AREANAME, "ReceiptText", NULL, TRANS_NO_SPECIFIED);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}
	
	MF_DECORATE tDecorate;
	tDecorate.dwAttribute = MF_PRINT_NO_ATTRIBUTE;
	tDecorate.wFont = MF_PRINT_FONT_A;
	tDecorate.szFontName = NULL;
	tDecorate.wFontSize = MF_PRINT_FONT_W1_H1;

	CString strReceiptText;
	CString strAddText;
	char *week[] = {"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
	char *pcReceiptText = NULL;
	SYSTEMTIME stSystemTime;

	GetSystemTime(&stSystemTime);
	strAddText.Format( _T("%02d/%02d/%04d %s %02d:%02d:%02d:%d\n"),
		stSystemTime.wDay, stSystemTime.wMonth,stSystemTime.wYear,week[stSystemTime.wDayOfWeek],
		stSystemTime.wHour, stSystemTime.wMinute, stSystemTime.wSecond, stSystemTime.wMilliseconds);
	strReceiptText += strAddText;

	strAddText.Format( _T("nTran #%5d\n"), ulTransactionNumber-1);
	strReceiptText += strAddText;

	strAddText.Format( _T("nEntity NCS CC 9999999 Tlr 99999\n") );
	strReceiptText += strAddText;

	strAddText.Format( _T("Acct Type SAV\n") );
	strReceiptText += strAddText;

	strAddText.Format( _T("Available Balance\t2000.00\n") );
	strReceiptText += strAddText;
		
	pcReceiptText = new char[strReceiptText.GetLength() + 1];
	strcpy_s( pcReceiptText, strReceiptText.GetLength() + 1, strReceiptText );

	nResult = BiPrintText(m_pCProperty->GetHandle(), pcReceiptText, tDecorate);
	ASSERT( nResult == SUCCESS );
	delete[] pcReceiptText;
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Print buffered printing data
	nResult = BiTemplatePrint(m_pCProperty->GetHandle(), TEMPLATEPRINT_EXEC);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	return nResult;
}

// Set contents of cashiers check printing
int CPrint::SetCashierscheckPrintSetting(void)
{
	int nResult = SUCCESS;

	// Set printing unit to cut sheet paper
	nResult = BiSetPrintStation(m_pCProperty->GetHandle(), MF_ST_FEEDER);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Compose path, API Driver supports only MBCS.
	char szPath[_MAX_PATH] = {0};
	(void)::GetModuleFileNameA (NULL, szPath, _countof(szPath));
	(void)::PathRemoveFileSpecA(szPath);
	(void)::PathAppendA        (szPath, "FormatSettingStep5.ini");

	// Load print information file for template printing
	int nLoadNum = 0;
	nResult = BiLoadTemplatePrintArea(m_pCProperty->GetHandle(), szPath, &nLoadNum);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	unsigned char ucScan = 0;
	if(m_pCProperty->GetAfterScanning() == true)
	{
		ucScan = BI_PRINTCUTSHEET_SCAN;
	}
	else
	{
		ucScan = BI_PRINTCUTSHEET_NOSCAN;
	}

	nResult = BiSetPrintCutSheetSettings(m_pCProperty->GetHandle(), m_pCProperty->GetPrintingNumber(), ucScan);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	return nResult;
}

// Set MF_SCAN structure for cashiers check printing
int CPrint::SetCashierscheckScanSetting(void)
{
	int nResult = SUCCESS;

	nResult = BiSCNSelectScanUnit(m_pCProperty->GetHandle(), EPS_BI_SCN_UNIT_CHECKPAPER);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSCNSelectScanFace(m_pCProperty->GetHandle(), MF_SCAN_FACE_FRONT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSCNSetImageTypeOption(m_pCProperty->GetHandle(), EPS_BI_SCN_OPTION_COLOR);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSCNSelectScanFace(m_pCProperty->GetHandle(), MF_SCAN_FACE_BACK);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiSCNSetImageTypeOption(m_pCProperty->GetHandle(), EPS_BI_SCN_OPTION_COLOR);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set scanning setting for printed side
	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), m_pCProperty->GetMfScanFront(), MF_GET_SCAN_PRINTAREA_DEFAULT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	m_pCProperty->GetMfScanFront()->iSize = sizeof(MF_SCAN);
	m_pCProperty->GetMfScanFront()->iVersion = MF_SCAN_VERSION;

	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), m_pCProperty->GetMfScanFront(), MF_SET_SCAN_PRINTAREA_PARAM);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set scanning setting for reverse side
	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), m_pCProperty->GetMfScanBack(), MF_GET_SCAN_NOPRINTAREA_DEFAULT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	m_pCProperty->GetMfScanBack()->iSize = sizeof(MF_SCAN);
	m_pCProperty->GetMfScanBack()->iVersion = MF_SCAN_VERSION;

	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), m_pCProperty->GetMfScanBack(), MF_SET_SCAN_NOPRINTAREA_PARAM);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	return nResult;
}

// Set MF_BASE structure for cashiers check printing
int CPrint::SetCashierscheckBaseSetting(void)
{
	int nResult = SUCCESS;

	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), m_pCProperty->GetMfBase01(), MF_GET_BASE_DEFAULT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	m_pCProperty->GetMfBase01()->iSize = sizeof(MF_BASE01);
	m_pCProperty->GetMfBase01()->iVersion = MF_BASE_VERSION01;

	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), m_pCProperty->GetMfBase01(), MF_SET_BASE_PARAM);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	return nResult;
}

// Perform cashiers check printing
int CPrint::PrintCashierscheck(void)
{
	int nResult = SUCCESS;

	nResult = BiPrintCutSheet(m_pCProperty->GetHandle(), NULL, MF_EXEC);
	ASSERT( nResult == SUCCESS );

	return nResult;
}

// Set contents of cashiers check printing
int CPrint::PrintCashierscheckFunction(void)
{
	int nResult = SUCCESS;

	// Start buffering of print data for template printing
	nResult = BiTemplatePrint(m_pCProperty->GetHandle(), TEMPLATEPRINT_BUFFERING);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set image data for printing
	nResult = BiSetTemplatePrintArea(m_pCProperty->GetHandle(), SELECTPRINTAREA_AREANAME, "CashiersSignature", NULL, TRANS_NO_SPECIFIED);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Compose path, API Driver supports only MBCS.
	char szPath[_MAX_PATH] = {0};
	(void)::GetModuleFileNameA (NULL, szPath, _countof(szPath));
	(void)::PathRemoveFileSpecA(szPath);
	(void)::PathAppendA        (szPath, "CashiersSign.bmp");

	nResult = BiPrintImage(m_pCProperty->GetHandle(), szPath);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Set print text
	MF_DECORATE tDecorate;
	tDecorate.dwAttribute	= MF_PRINT_NO_ATTRIBUTE;
	tDecorate.wFont			= MF_PRINT_FONT_A;
	tDecorate.szFontName	= NULL;
	tDecorate.wFontSize		= MF_PRINT_FONT_W1_H1;

	char *pashiersString = NULL;
	CString strTimeString;
	SYSTEMTIME stSystemTime;
	char *pcMonth[] = {"","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

	/*Date*/
	nResult = BiSetTemplatePrintArea(m_pCProperty->GetHandle(), SELECTPRINTAREA_AREANAME, "CashiersDate", NULL, TRANS_NO_SPECIFIED);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	GetSystemTime(&stSystemTime);

	strTimeString.Format( _T("%s %02d,%4d"), pcMonth[stSystemTime.wMonth], stSystemTime.wDay, stSystemTime.wYear);
	pashiersString = new char[strTimeString.GetLength() + 1];
	strcpy_s( pashiersString, strTimeString.GetLength() + 1, strTimeString );

	nResult = BiPrintText(m_pCProperty->GetHandle(), pashiersString, tDecorate);
	delete[] pashiersString;
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	/*Name*/
	tDecorate.wFontSize = MF_PRINT_FONT_W2_H1;
	
	nResult = BiSetTemplatePrintArea(m_pCProperty->GetHandle(), SELECTPRINTAREA_AREANAME, "CashiersName", NULL, TRANS_NO_SPECIFIED);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pashiersString = "Taro Nanashi";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pashiersString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	/*OrderNum*/
	nResult = BiSetTemplatePrintArea(m_pCProperty->GetHandle(), SELECTPRINTAREA_AREANAME, "CashiersOrderNum", NULL, TRANS_NO_SPECIFIED);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pashiersString = "2500.00";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pashiersString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	/*OrderNum*/
	nResult = BiSetTemplatePrintArea(m_pCProperty->GetHandle(), SELECTPRINTAREA_AREANAME, "CashiersOrderString", NULL, TRANS_NO_SPECIFIED);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pashiersString = "Two thousand five hundred and 00 Cents";
	nResult = BiPrintText(m_pCProperty->GetHandle(), pashiersString, tDecorate);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// Print buffered printing data
	nResult = BiTemplatePrint(m_pCProperty->GetHandle(), TEMPLATEPRINT_EXEC);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	return nResult;
}

// Check if the roll paper is supported as print station.
bool CPrint::IsRollPaperSupported(void)
{
	int nResult = BiSetPrintStation(m_pCProperty->GetHandle(), MF_ST_ROLLPAPER);
	if(nResult == SUCCESS)
	{
		return true;
	}
	else
	{
		return false;
	}
}

// Get functions of the API
void CPrint::GetAPIProcAddress(void)
{
	HINSTANCE hLibrary = m_pCProperty->GetLibrary();

	BiSetPrintStation			= (DLL_BiSetPrintStation)			GetProcAddress(hLibrary, "BiSetPrintStation");
	BiBufferedPrint				= (DLL_BiBufferedPrint)				GetProcAddress(hLibrary, "BiBufferedPrint");
	BiSetPrintAlignment			= (DLL_BiSetPrintAlignment)			GetProcAddress(hLibrary, "BiSetPrintAlignment");
	BiPrintText					= (DLL_BiPrintText)					GetProcAddress(hLibrary, "BiPrintText");
	BiSetPrintSize				= (DLL_BiSetPrintSize)				GetProcAddress(hLibrary, "BiSetPrintSize");
	BiPrintImage				= (DLL_BiPrintImage)				GetProcAddress(hLibrary, "BiPrintImage");
	BiPrintBarCode				= (DLL_BiPrintBarCode)				GetProcAddress(hLibrary, "BiPrintBarCode");
	BiLoadTemplatePrintArea		= (DLL_BiLoadTemplatePrintArea)		GetProcAddress(hLibrary, "BiLoadTemplatePrintArea");
	BiTemplatePrint				= (DLL_BiTemplatePrint)				GetProcAddress(hLibrary, "BiTemplatePrint");
	BiSetTemplatePrintArea		= (DLL_BiSetTemplatePrintArea)		GetProcAddress(hLibrary, "BiSetTemplatePrintArea");
	BiPrintCutSheet				= (DLL_BiPrintCutSheet)				GetProcAddress(hLibrary, "BiPrintCutSheet");
	BiSetPrintCutSheetSettings	= (DLL_BiSetPrintCutSheetSettings)	GetProcAddress(hLibrary, "BiSetPrintCutSheetSettings");
	BiSCNSetImageTypeOption		= (DLL_BiSCNSetImageTypeOption)		GetProcAddress(hLibrary, "BiSCNSetImageTypeOption");
	BiSCNSelectScanFace			= (DLL_BiSCNSelectScanFace)			GetProcAddress(hLibrary, "BiSCNSelectScanFace");
	BiAutoCutRollPaper			= (DLL_BiAutoCutRollPaper)			GetProcAddress(hLibrary, "BiAutoCutRollPaper");
	BiSCNSelectScanUnit			= (DLL_BiSCNSelectScanUnit)			GetProcAddress(hLibrary, "BiSCNSelectScanUnit");
}
