
#define STR_NAME_MUTEX	_T("Mutex EPSON TM-S Sample Program Step8")

typedef struct tagConfigData
{
	// Step 2
	int	nRadio_ScanningMedia;
	int	nRadio_LightSourceToScan;
	int	nRadio_RGBColorDepth;
	int	nRadio_IRColorDepth;
	int	nCombo_Resolution;
	int nEdit_NumberOfDocuments;
	int	nCheck_Scan_SaveFile;
	bool bIsScanningCardIR1PassSupported;

	// Step 3
	int	nRadio_MICRFont;
	int	nCheck_MICR_ClearSpace;
	int	nCheck_MICR_SaveFile;

	// Step 8
	int nCheck_PI_Detect;
	int nCheck_PI_Cancel;
	int nCombo_PI_EjectPocket;
	int nCheck_NO_Detect;
	int nCheck_NO_Cancel;
	int nCombo_NO_EjectPocket;
	int nCheck_DF_Detect;
	int nCheck_DF_Cancel;
	int nCombo_DF_EjectPocket;
	int nCheck_BD_Detect;
	int nCheck_BD_Cancel;
	int nCombo_BD_EjectPocket;
	int nCheck_ND_Detect;
	int nCheck_ND_Cancel;
	int nCombo_ND_EjectPocket;
	int nCheck_BA_Detect;
	int nCheck_BA_Cancel;
	int nCombo_BA_EjectPocket;

	// Step 8
	bool bCheck_BT_SymbolCodabar;
	bool bCheck_BT_SymbolCode128;
	bool bCheck_BT_SymbolCode39;
	bool bCheck_BT_SymbolITF;
	bool bCheck_BT_SymbolEAN;
	bool bCheck_BT_SymbolUPCA;
	bool bCheck_BT_SymbolUPCE;

	tagConfigData(void)
	{
		// Step 2
		nRadio_ScanningMedia		= VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
		nRadio_LightSourceToScan	= VAL_CONFIGDLG_RADIO_IC_RGB;
		nRadio_RGBColorDepth		= VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
		nRadio_IRColorDepth			= VAL_CONFIGDLG_RADIO_IRCD_GRAY;
		nCombo_Resolution			= VAL_CONFIGDLG_COMBO_RE_200200;
		nEdit_NumberOfDocuments		= 0;
		nCheck_Scan_SaveFile		= VAL_CONFIGDLG_CHECK_SC_SAVEFILE_ON;
		bIsScanningCardIR1PassSupported = false;

		// Step 3
		nRadio_MICRFont				= VAL_CONFIGDLG_RADIO_MF_E13B;
		nCheck_MICR_ClearSpace		= VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_OFF;
		nCheck_MICR_SaveFile		= VAL_CONFIGDLG_CHECK_MI_SAVEFILE_OFF;

		// Step 8
		nCheck_PI_Detect			= VAL_CONFIGDLG_CHECK_PI_DETECT_OFF;
		nCheck_PI_Cancel			= VAL_CONFIGDLG_CHECK_PI_CANCEL_OFF;
		nCombo_PI_EjectPocket		= VAL_CONFIGDLG_COMBO_PI_EP_MAINPOCKET;
		nCheck_NO_Detect			= VAL_CONFIGDLG_CHECK_NO_DETECT_OFF;
		nCheck_NO_Cancel			= VAL_CONFIGDLG_CHECK_NO_CANCEL_OFF;
		nCombo_NO_EjectPocket		= VAL_CONFIGDLG_COMBO_NO_EP_MAINPOCKET;
		nCheck_DF_Detect			= VAL_CONFIGDLG_CHECK_DF_DETECT_OFF;
		nCheck_DF_Cancel			= VAL_CONFIGDLG_CHECK_DF_CANCEL_OFF;
		nCombo_DF_EjectPocket		= VAL_CONFIGDLG_COMBO_DF_EP_MAINPOCKET;
		nCheck_BD_Detect			= VAL_CONFIGDLG_CHECK_BD_DETECT_OFF;
		nCheck_BD_Cancel			= VAL_CONFIGDLG_CHECK_BD_CANCEL_OFF;
		nCombo_BD_EjectPocket		= VAL_CONFIGDLG_COMBO_BD_EP_MAINPOCKET;
		nCheck_ND_Detect			= VAL_CONFIGDLG_CHECK_ND_DETECT_OFF;
		nCheck_ND_Cancel			= VAL_CONFIGDLG_CHECK_ND_CANCEL_OFF;
		nCombo_ND_EjectPocket		= VAL_CONFIGDLG_COMBO_ND_EP_MAINPOCKET;
		nCheck_BA_Detect			= VAL_CONFIGDLG_CHECK_BA_DETECT_OFF;
		nCheck_BA_Cancel			= VAL_CONFIGDLG_CHECK_BA_CANCEL_OFF;
		nCombo_BA_EjectPocket		= VAL_CONFIGDLG_COMBO_BA_EP_MAINPOCKET;

		// Step 8
		bCheck_BT_SymbolCodabar = false;
		bCheck_BT_SymbolCode128 = false;
		bCheck_BT_SymbolCode39  = false;
		bCheck_BT_SymbolITF     = false;
		bCheck_BT_SymbolEAN     = false;
		bCheck_BT_SymbolUPCA    = false;
		bCheck_BT_SymbolUPCE    = false;
	}

	void Copy( const tagConfigData & sData )
	{
		// Step 2
		nRadio_ScanningMedia		= sData.nRadio_ScanningMedia;
		nRadio_LightSourceToScan	= sData.nRadio_LightSourceToScan;
		nRadio_RGBColorDepth		= sData.nRadio_RGBColorDepth;
		nRadio_IRColorDepth			= sData.nRadio_IRColorDepth;
		nCombo_Resolution			= sData.nCombo_Resolution;
		nEdit_NumberOfDocuments		= sData.nEdit_NumberOfDocuments;
		nCheck_Scan_SaveFile		= sData.nCheck_Scan_SaveFile;
		bIsScanningCardIR1PassSupported = sData.bIsScanningCardIR1PassSupported;

		// Step 3
		nRadio_MICRFont				= sData.nRadio_MICRFont;
		nCheck_MICR_ClearSpace		= sData.nCheck_MICR_ClearSpace;
		nCheck_MICR_SaveFile		= sData.nCheck_MICR_SaveFile;

		// Step 8
		nCheck_PI_Detect			= sData.nCheck_PI_Detect;
		nCheck_PI_Cancel			= sData.nCheck_PI_Cancel;
		nCombo_PI_EjectPocket		= sData.nCombo_PI_EjectPocket;
		nCheck_NO_Detect			= sData.nCheck_NO_Detect;
		nCheck_NO_Cancel			= sData.nCheck_NO_Cancel;
		nCombo_NO_EjectPocket		= sData.nCombo_NO_EjectPocket;
		nCheck_DF_Detect			= sData.nCheck_DF_Detect;
		nCheck_DF_Cancel			= sData.nCheck_DF_Cancel;
		nCombo_DF_EjectPocket		= sData.nCombo_DF_EjectPocket;
		nCheck_BD_Detect			= sData.nCheck_BD_Detect;
		nCheck_BD_Cancel			= sData.nCheck_BD_Cancel;
		nCombo_BD_EjectPocket		= sData.nCombo_BD_EjectPocket;
		nCheck_ND_Detect			= sData.nCheck_ND_Detect;
		nCheck_ND_Cancel			= sData.nCheck_ND_Cancel;
		nCombo_ND_EjectPocket		= sData.nCombo_ND_EjectPocket;
		nCheck_BA_Detect			= sData.nCheck_BA_Detect;
		nCheck_BA_Cancel			= sData.nCheck_BA_Cancel;
		nCombo_BA_EjectPocket		= sData.nCombo_BA_EjectPocket;

		// Step 8
		bCheck_BT_SymbolCodabar		= sData.bCheck_BT_SymbolCodabar;
		bCheck_BT_SymbolCode128		= sData.bCheck_BT_SymbolCode128;
		bCheck_BT_SymbolCode39		= sData.bCheck_BT_SymbolCode39;
		bCheck_BT_SymbolITF			= sData.bCheck_BT_SymbolITF;
		bCheck_BT_SymbolEAN			= sData.bCheck_BT_SymbolEAN;
		bCheck_BT_SymbolUPCA		= sData.bCheck_BT_SymbolUPCA;
		bCheck_BT_SymbolUPCE		= sData.bCheck_BT_SymbolUPCE;
	}
} CONFIGDATA, *LPCONFIGDATA;
