////////////////
//// Step 8 ////
////////////////

// DeviceInfoDlg.cpp : Implementation
//

#include "stdafx.h"
#include "Resource.h"
#include "DeviceInfoDlg.h"


// DeviceInfoDlg Dialog

IMPLEMENT_DYNAMIC(CDeviceInfoDlg, CDialog)

CDeviceInfoDlg::CDeviceInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDeviceInfoDlg::IDD, pParent)
{
}

CDeviceInfoDlg::~CDeviceInfoDlg(void)
{
}

void CDeviceInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_BUTTON_DI_CLOSE, m_btnClose);

	DDX_Control(pDX, IDC_EDIT_DI_DEVICENAME,			m_edtDIDeviceName);
	DDX_Control(pDX, IDC_EDIT_DI_FIRMWAREVERSION,		m_edtDIFirmwareVersion);
	DDX_Control(pDX, IDC_EDIT_DI_MANUFACTURE,			m_edtDIManufacture);
	DDX_Control(pDX, IDC_EDIT_DI_SERIALNUMBER,			m_edtDISerialNumber);
	DDX_Control(pDX, IDC_EDIT_DI_SPEED,					m_edtDISpeed);
	DDX_Control(pDX, IDC_EDIT_DI_POCKET,				m_edtDIPocket);
	DDX_Control(pDX, IDC_EDIT_MC_CHECKSCAN,				m_edtMCScanedCheck);
	DDX_Control(pDX, IDC_EDIT_MC_CARDSCAN,				m_edtMCScanedCard);
	DDX_Control(pDX, IDC_EDIT_MC_LINEFEEDS,				m_edtMCLineFeeds);        // S9000 only
	DDX_Control(pDX, IDC_EDIT_MC_PUMPOPERATION,			m_edtMCPumpOperation);
	DDX_Control(pDX, IDC_EDIT_MC_MICRREADS,				m_edtMCMicrRead);
	DDX_Control(pDX, IDC_EDIT_MC_HEADSHOTA,				m_edtMCHeadShotA);
	DDX_Control(pDX, IDC_EDIT_MC_HEADSHOTB,				m_edtMCHeadShotB);
	DDX_Control(pDX, IDC_EDIT_MC_HEADENERGIZATION,		m_edtMCHeadEnergization); // S9000 only
	DDX_Control(pDX, IDC_EDIT_MC_ASFSENDINGOFF,			m_edtMCAsfSendingOff);
	DDX_Control(pDX, IDC_EDIT_MC_HEADLINEFEEDS,			m_edtMCHeadLineFeeds);    // S9000 only
	DDX_Control(pDX, IDC_EDIT_MC_AUTOCUTTER,			m_edtMCAutoCutter);       // S9000 only
	DDX_Control(pDX, IDC_EDIT_MC_HOPPER,				m_edtMCHopper);
	DDX_Control(pDX, IDC_EDIT_MC_POCKETSELECT,			m_edtMCPocketSelect);
	DDX_Control(pDX, IDC_EDIT_MC_DEVICEOPERATIONTIME,	m_edtMCDeviceOperationTime);

	DDX_Control(pDX, IDC_STATIC_DI_DEVICENAME,			m_stDIDeviceName);
	DDX_Control(pDX, IDC_STATIC_DI_FIRMWAREVERSION,		m_stDIFirmwareVersion);
	DDX_Control(pDX, IDC_STATIC_DI_MANUFACTURE,			m_stDIManufacture);
	DDX_Control(pDX, IDC_STATIC_DI_SERIALNUMBER,		m_stDISerialNumber);
	DDX_Control(pDX, IDC_STATIC_DI_SPEED,				m_stDISpeed);
	DDX_Control(pDX, IDC_STATIC_DI_POCKET,				m_stDIPocket);
	DDX_Control(pDX, IDC_STATIC_MC_CHECKSCAN,			m_stMCScanedCheck);
	DDX_Control(pDX, IDC_STATIC_MC_CARDSCAN,			m_stMCScanedCard);
	DDX_Control(pDX, IDC_STATIC_MC_LINEFEEDS,			m_stMCLineFeeds);         // S9000 only
	DDX_Control(pDX, IDC_STATIC_MC_PUMPOPERATION,		m_stMCPumpOperation);
	DDX_Control(pDX, IDC_STATIC_MC_MICRREADS,			m_stMCMicrRead);
	DDX_Control(pDX, IDC_STATIC_MC_HEADSHOTA,			m_stMCHeadShotA);
	DDX_Control(pDX, IDC_STATIC_MC_HEADSHOTB,			m_stMCHeadShotB);
	DDX_Control(pDX, IDC_STATIC_MC_HEADENERGIZATION,	m_stMCHeadEnergization);  // S9000 only
	DDX_Control(pDX, IDC_STATIC_MC_ASFSENDINGOFF,		m_stMCAsfSendingOff);
	DDX_Control(pDX, IDC_STATIC_MC_HEADLINEFEEDS,		m_stMCHeadLineFeeds);     // S9000 only
	DDX_Control(pDX, IDC_STATIC_MC_AUTOCUTTER,			m_stMCAutoCutter);        // S9000 only
	DDX_Control(pDX, IDC_STATIC_MC_HOPPER,				m_stMCHopper);
	DDX_Control(pDX, IDC_STATIC_MC_POCKETSELECT,		m_stMCPocketSelect);
	DDX_Control(pDX, IDC_STATIC_MC_DEVICEOPERATIONTIME,	m_stMCDeviceOperationTime);

	DDX_Control(pDX, IDC_GROUP_DEVICEINFO,				m_stGroupDeviceInfo);
	DDX_Control(pDX, IDC_GROUP_MAINTENANCECOUNTER,		m_stGroupMaintenanceCounter);
}

BEGIN_MESSAGE_MAP(CDeviceInfoDlg, CDialog)

	ON_BN_CLICKED(IDC_BUTTON_DI_CLOSE, &CDeviceInfoDlg::OnBnClickedClose)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////
// CDeviceInfoDlg message handlers
/////////////////////////////////////////////////////////////////

BOOL CDeviceInfoDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();

	LoadResourceString();

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CDeviceInfoDlg::LoadResourceString(void)
{
	m_btnClose.SetWindowText( STR_DEVICEINFODLG_BUTTON_CLOSE );

	m_stDIDeviceName.SetWindowText( STR_DEVICEINFODLG_STATIC_DI_DEVICENAME );
	m_stDIFirmwareVersion.SetWindowText( STR_DEVICEINFODLG_STATIC_DI_FIRMWAREVERSION );
	m_stDIManufacture.SetWindowText( STR_DEVICEINFODLG_STATIC_DI_MANUFACTURE );
	m_stDISerialNumber.SetWindowText( STR_DEVICEINFODLG_STATIC_DI_SERIALNUMBER );
	m_stDISpeed.SetWindowText( STR_DEVICEINFODLG_STATIC_DI_SPEED );
	m_stDIPocket.SetWindowText( STR_DEVICEINFODLG_STATIC_DI_POCKET );
	m_stMCScanedCheck.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_CHECKSCAN );
	m_stMCScanedCard.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_CARDSCAN );
	m_stMCLineFeeds.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_LINEFEEDS );               // S9000 only
	m_stMCPumpOperation.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_PUMPOPERATION );
	m_stMCMicrRead.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_MICRREADS );
	m_stMCHeadShotA.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_HEADSHOTA );
	m_stMCHeadShotB.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_HEADSHOTB );
	m_stMCHeadEnergization.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_HEADENERGIZATION ); // S9000 only
	m_stMCAsfSendingOff.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_ASFSENDINGOFF );
	m_stMCHeadLineFeeds.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_HEADLINEFEEDS );       // S9000 only
	m_stMCAutoCutter.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_AUTOCUTTER );             // S9000 only
	m_stMCHopper.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_HOPPER );
	m_stMCPocketSelect.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_POCKETSELECT );
	m_stMCDeviceOperationTime.SetWindowText( STR_DEVICEINFODLG_STATIC_MC_DEVICEOPERATIONTIME );

	m_stGroupDeviceInfo.SetWindowText( STR_DEVICEINFODLG_GROUP_DEVICEINFO );
	m_stGroupMaintenanceCounter.SetWindowText( STR_DEVICEINFODLG_GROUP_MAINTENANCECOUNTER );
}

void CDeviceInfoDlg::DisplayDeviceInfo( CDeviceInfo* pcDeviceInfo )
{
	if(pcDeviceInfo ==NULL)
	{
		return;
	}

	m_edtDIDeviceName.SetWindowText((LPSTR)pcDeviceInfo->GetDeviceName());
	m_edtDIFirmwareVersion.SetWindowText((LPSTR)pcDeviceInfo->GetFirmVersion());
	m_edtDIManufacture.SetWindowText((LPSTR)pcDeviceInfo->GetManufacture());
	m_edtDISerialNumber.SetWindowText((LPSTR)pcDeviceInfo->GetSerialNumber());

	if( ((DWORD)*pcDeviceInfo->GetTypeIdB() & TWO_POCKET_MODEL) == TWO_POCKET_MODEL )
	{
		m_edtDIPocket.SetWindowText(_T("2 pocket"));
	}
	else
	{
		m_edtDIPocket.SetWindowText(_T("1 pocket"));
	}

	if( (*pcDeviceInfo->GetTypeIdB() & SCAN_200DPM_MODEL) == SCAN_200DPM_MODEL )
	{
		m_edtDISpeed.SetWindowText(_T("200DPM"));
	}
	else if( (*pcDeviceInfo->GetTypeIdB() & SCAN_110DPM_MODEL) == SCAN_110DPM_MODEL )
	{
		m_edtDISpeed.SetWindowText(_T("110DPM"));
	}
}

void CDeviceInfoDlg::DisplayMaintenanceCounter( CMaintenanceCounter* pcMaintenanceCounter )
{
	if(pcMaintenanceCounter ==NULL)
	{
		return;
	}

	DisplayDWORDOnEdit( m_edtMCScanedCheck,         pcMaintenanceCounter->GetImageScannedCheckPaper() );
	DisplayDWORDOnEdit( m_edtMCScanedCard,          pcMaintenanceCounter->GetImageScannedCard() );
	DisplayDWORDOnEdit( m_edtMCLineFeeds,           pcMaintenanceCounter->GetLineFeeds() );        // S9000 only
	DisplayDWORDOnEdit( m_edtMCPumpOperation,       pcMaintenanceCounter->GetPumpOperation() );
	DisplayDWORDOnEdit( m_edtMCMicrRead,            pcMaintenanceCounter->GetMicrReads() );
	DisplayDWORDOnEdit( m_edtMCHeadShotA,           pcMaintenanceCounter->GetHeadShotA() );
	DisplayDWORDOnEdit( m_edtMCHeadShotB,           pcMaintenanceCounter->GetHeadShotB() );
	DisplayDWORDOnEdit( m_edtMCHeadEnergization,    pcMaintenanceCounter->GetHeadEnergization() ); // S9000 only
	DisplayDWORDOnEdit( m_edtMCAsfSendingOff,       pcMaintenanceCounter->GetAsfSendingOff() );
	DisplayDWORDOnEdit( m_edtMCHeadLineFeeds,       pcMaintenanceCounter->GetHeadLineFeeds() );    // S9000 only
	DisplayDWORDOnEdit( m_edtMCAutoCutter,          pcMaintenanceCounter->GetAutoCutter() );       // S9000 only
	DisplayDWORDOnEdit( m_edtMCHopper,              pcMaintenanceCounter->GetHopper() );
	DisplayDWORDOnEdit( m_edtMCPocketSelect,        pcMaintenanceCounter->GetPocketSelect() );
	DisplayDWORDOnEdit( m_edtMCDeviceOperationTime, pcMaintenanceCounter->GetDeviceOperationTime() );
}

void CDeviceInfoDlg::DisplayDWORDOnEdit( CEdit& edit, DWORD dw )
{
	TCHAR buf[1024] = {0};
	if ( dw != static_cast<DWORD>( -1 ) )
	{
		// S9000
		edit.EnableWindow( TRUE );
		edit.SetWindowText( ::_itot(dw,buf,10) );
	}
	else
	{
		// S2000
		edit.EnableWindow( FALSE );
		edit.SetWindowText( _T("N/A") );
	}
}

void CDeviceInfoDlg::OnBnClickedClose(void)
{
	OnCancel();
}
