////////////////
//// Step 8 ////
////////////////

// DeviceStatusDlg.cpp : Implementation
//

#include "stdafx.h"
#include "Resource.h"
#include "DeviceStatusDlg.h"


// DeviceStatusDlg dialog

IMPLEMENT_DYNAMIC(CDeviceStatusDlg, CDialog)

CDeviceStatusDlg::CDeviceStatusDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDeviceStatusDlg::IDD, pParent)
{
}

CDeviceStatusDlg::~CDeviceStatusDlg(void)
{
}

void CDeviceStatusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_BUTTON_DS_CLOSE, m_btnClose);

	DDX_Control(pDX, IDC_CHECK_NORESPONSE,			m_btnCheckDSNoResponse);
	DDX_Control(pDX, IDC_CHECK_OFFLINE,				m_btnCheckDSOffLine);
	DDX_Control(pDX, IDC_CHECK_COVEROPEN,			m_btnCheckDSCoverOpen);
	DDX_Control(pDX, IDC_CHECK_WAITPAPEREJECT,		m_btnCheckDSWaitPaperEject);
	DDX_Control(pDX, IDC_CHECK_MECHANICALERR,		m_btnCheckDSMechanicalErr);
	DDX_Control(pDX, IDC_CHECK_UNRECOVERERR,		m_btnCheckDSUnrecoverErr);
	DDX_Control(pDX, IDC_CHECK_PAPERINTERMEDIATE,	m_btnCheckDSPaperIntermediate);
	DDX_Control(pDX, IDC_CHECK_RECEIPTNEAREND,		m_btnCheckDSReceiptNearEnd);     // S9000 only
	DDX_Control(pDX, IDC_CHECK_EJECTSENSORNOPAPER,	m_btnCheckDSEjectSensorNoPaper);
	DDX_Control(pDX, IDC_CHECK_RECEIPTEND,			m_btnCheckDSReceiptEnd);         // S9000 only
	DDX_Control(pDX, IDC_CHECK_SLIPPAPERSIZE,		m_btnCheckDSSlipPaperSize);
	DDX_Control(pDX, IDC_CHECK_ASFPAPER,			m_btnCheckDSAsfPaper);
	DDX_Control(pDX, IDC_CHECK_WAITINSERT,			m_btnCheckDSWaitInsert);
	DDX_Control(pDX, IDC_CHECK_MAINPOCKETNEARFULL,	m_btnCheckDSMainPocketNearFull);
	DDX_Control(pDX, IDC_CHECK_SUBPOCKETNEARFULL,	m_btnCheckDSSubPocketNearFull);

	DDX_Control(pDX, IDC_CHECK_INKNEAREND,			m_btnCheckISInkNearEnd);
	DDX_Control(pDX, IDC_CHECK_INKEND,				m_btnCheckISInkEnd);
	DDX_Control(pDX, IDC_CHECK_INKNOCARTRIDGE,		m_btnCheckISInkNoCartridge);
	DDX_Control(pDX, IDC_CHECK_INKCLEANING,			m_btnCheckISInkCleaning);

	DDX_Control(pDX, IDC_GROUP_DEVICESTATUS,		m_stGroupDeviceStatus);
	DDX_Control(pDX, IDC_GROUP_INKSTATUS,			m_stGroupInkStatus);
}

BEGIN_MESSAGE_MAP(CDeviceStatusDlg, CDialog)

	ON_BN_CLICKED(IDC_BUTTON_DS_CLOSE, &CDeviceStatusDlg::OnBnClickedClose)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////
// CDeviceStatusDlg message handlers
/////////////////////////////////////////////////////////////////

BOOL CDeviceStatusDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();

	LoadResourceString();


	return TRUE;  // return TRUE unless you set the focus to a control
}

void CDeviceStatusDlg::LoadResourceString(void)
{
	m_btnClose.SetWindowText( STR_DEVICESTATUSDLG_BUTTON_CLOSE );

	m_btnCheckDSNoResponse.SetWindowText( STR_DEVICESTATUSDLG_CHECK_NORESPONSE );
	m_btnCheckDSOffLine.SetWindowText( STR_DEVICESTATUSDLG_CHECK_OFFLINE );
	m_btnCheckDSCoverOpen.SetWindowText( STR_DEVICESTATUSDLG_CHECK_COVEROPEN );
	m_btnCheckDSWaitPaperEject.SetWindowText( STR_DEVICESTATUSDLG_CHECK_WAITPAPEREJECT );
	m_btnCheckDSMechanicalErr.SetWindowText( STR_DEVICESTATUSDLG_CHECK_MECHANICALERR );
	m_btnCheckDSUnrecoverErr.SetWindowText( STR_DEVICESTATUSDLG_CHECK_UNRECOVERERR );
	m_btnCheckDSPaperIntermediate.SetWindowText( STR_DEVICESTATUSDLG_CHECK_PAPERINTERMEDIATE );
	m_btnCheckDSReceiptNearEnd.SetWindowText( STR_DEVICESTATUSDLG_CHECK_RECEIPTNEAREND );         // S9000 only
	m_btnCheckDSEjectSensorNoPaper.SetWindowText( STR_DEVICESTATUSDLG_CHECK_EJECTSENSORNOPAPER );
	m_btnCheckDSReceiptEnd.SetWindowText( STR_DEVICESTATUSDLG_CHECK_RECEIPTEND );                 // S9000 only
	m_btnCheckDSSlipPaperSize.SetWindowText( STR_DEVICESTATUSDLG_CHECK_SLIPPAPERSIZE );
	m_btnCheckDSAsfPaper.SetWindowText( STR_DEVICESTATUSDLG_CHECK_ASFPAPER );
	m_btnCheckDSWaitInsert.SetWindowText( STR_DEVICESTATUSDLG_CHECK_WAITINSERT );
	m_btnCheckDSMainPocketNearFull.SetWindowText( STR_DEVICESTATUSDLG_CHECK_MAINPOCKETNEARFULL );
	m_btnCheckDSSubPocketNearFull.SetWindowText( STR_DEVICESTATUSDLG_CHECK_SUBPOCKETNEARFULL );

	m_btnCheckISInkNearEnd.SetWindowText( STR_DEVICESTATUSDLG_CHECK_INKNEAREND );
	m_btnCheckISInkEnd.SetWindowText( STR_DEVICESTATUSDLG_CHECK_INKEND );
	m_btnCheckISInkNoCartridge.SetWindowText( STR_DEVICESTATUSDLG_CHECK_INKNOCARTRIDGE );
	m_btnCheckISInkCleaning.SetWindowText( STR_DEVICESTATUSDLG_CHECK_INKCLEANING );

	m_stGroupDeviceStatus.SetWindowText( STR_DEVICESTATUSDLG_GROUP_DEVICESTATUS );
	m_stGroupInkStatus.SetWindowText( STR_DEVICESTATUSDLG_GROUP_INKSTATU );
}

void CDeviceStatusDlg::DisplayDeviceStatus(CDeviceStatus* pcDeviceStatus)
{
	if(pcDeviceStatus ==NULL)
	{
		return;
	}

	if( pcDeviceStatus->GetNoResponse() == true )
	{
		SetCheckBox(true,  &m_btnCheckDSNoResponse);
		SetCheckBox(false, &m_btnCheckDSOffLine);
		SetCheckBox(false, &m_btnCheckDSCoverOpen);
		SetCheckBox(false, &m_btnCheckDSWaitPaperEject);
		SetCheckBox(false, &m_btnCheckDSMechanicalErr);
		SetCheckBox(false, &m_btnCheckDSUnrecoverErr);
		SetCheckBox(false, &m_btnCheckDSPaperIntermediate);
		SetCheckBox(false, &m_btnCheckDSReceiptNearEnd);     // S9000 only
		SetCheckBox(false, &m_btnCheckDSEjectSensorNoPaper);
		SetCheckBox(false, &m_btnCheckDSReceiptEnd);         // S9000 only
		SetCheckBox(false, &m_btnCheckDSSlipPaperSize);
		SetCheckBox(false, &m_btnCheckDSAsfPaper);
		SetCheckBox(false, &m_btnCheckDSWaitInsert);
		SetCheckBox(false, &m_btnCheckDSMainPocketNearFull);
		SetCheckBox(false, &m_btnCheckDSSubPocketNearFull);
	}
	else if( pcDeviceStatus->GetNoResponse() == false )
	{
		SetCheckBox(false, &m_btnCheckDSNoResponse);
		SetCheckBox(pcDeviceStatus->GetOffLine(), &m_btnCheckDSOffLine);
		SetCheckBox(pcDeviceStatus->GetCoverOpen(), &m_btnCheckDSCoverOpen);
		SetCheckBox(pcDeviceStatus->GetWaitPaperEject(), &m_btnCheckDSWaitPaperEject);
		SetCheckBox(pcDeviceStatus->GetMechanicalError(), &m_btnCheckDSMechanicalErr);
		SetCheckBox(pcDeviceStatus->GetUnrecoverError(), &m_btnCheckDSUnrecoverErr);
		SetCheckBox(!pcDeviceStatus->GetPaperInsermadiate(), &m_btnCheckDSPaperIntermediate);
		SetCheckBox(pcDeviceStatus->GetReceiptNearEnd(), &m_btnCheckDSReceiptNearEnd);        // S9000 only
		SetCheckBox(!pcDeviceStatus->GetEjectSensorPaper(), &m_btnCheckDSEjectSensorNoPaper);
		SetCheckBox(pcDeviceStatus->GetReceiptEnd(), &m_btnCheckDSReceiptEnd);                // S9000 only
		SetCheckBox(!pcDeviceStatus->GetSlipPaperSize(), &m_btnCheckDSSlipPaperSize);
		SetCheckBox(!pcDeviceStatus->GetAsfPaper(), &m_btnCheckDSAsfPaper);
		SetCheckBox(pcDeviceStatus->GetWaitInsert(), &m_btnCheckDSWaitInsert);
		SetCheckBox(pcDeviceStatus->GetMainPocketNearFull(), &m_btnCheckDSMainPocketNearFull);
		SetCheckBox(pcDeviceStatus->GetSubPocketNearFull(), &m_btnCheckDSSubPocketNearFull);
	}
}

void CDeviceStatusDlg::DisplayInkStatus(CInkStatus* pcInkStatus)
{
	if(pcInkStatus ==NULL)
	{
		return;
	}

	SetCheckBox(pcInkStatus->GetInkNearEnd(), &m_btnCheckISInkNearEnd);
	SetCheckBox(pcInkStatus->GetInkEnd(), &m_btnCheckISInkEnd);
	SetCheckBox(pcInkStatus->GetInkNoCartridge(), &m_btnCheckISInkNoCartridge);
	SetCheckBox(pcInkStatus->GetInkCleaning(), &m_btnCheckISInkCleaning);
}

void CDeviceStatusDlg::SetCheckBox(bool bResult, CButton* pbtnControl )
{
	if( pbtnControl == NULL )
	{
		return;
	}

	if( bResult == true )
	{
		pbtnControl->SetCheck(1);
	}
	else if( bResult == false )
	{
		pbtnControl->SetCheck(0);
	}
}

void CDeviceStatusDlg::OnBnClickedClose(void)
{
	OnCancel();
}
