#if !defined(SAMPLE_e974b440_a6a1_11e0_8264_0800200c9a66)
#define SAMPLE_e974b440_a6a1_11e0_8264_0800200c9a66

#pragma once

#include "Property_1.h"
#include "DeviceStatus.h"
#include "InkStatus.h"
#include "DeviceInfo.h"
#include "MaintenanceCounter.h"

#define INFO_DEVICE_NAME	67
#define INFO_MANUFACTURE	66
#define INFO_FIRM_VERSION	65
#define INFO_SERIAL_NUMBER	68
#define INFO_SPEED_POCKET	112

#define MAX_DEVICE_INFO_SIZE	80

#define COUNTER_HEAD_ENERGIZATION		21 // S9000 only
#define COUNTER_HEAD_LINE_FEEDS			22 // S9000 only
#define COUNTER_LINE_FEEDS				30 // S9000 only
#define COUNTER_HEAD_SHOT_A				31
#define COUNTER_HEAD_SHOT_B				32
#define COUNTER_PUMP_OPERATION			34
#define COUNTER_AUTO_CUTTER				50 // S9000 only
#define COUNTER_ASF_SENDING_OFF			67
#define COUNTER_SCANNED_CHECK			61
#define COUNTER_SCANNED_CARD			62
#define COUNTER_MICR_READS				60
#define COUNTER_POCKET_SELECT			82
#define COUNTER_HOPPER					80
#define COUNTER_DEVICE_OPERATION_TIME	70

class CInfo
{
private:
	CProperty_1*	m_pCProperty;

	DLL_BiGetCounter					BiGetCounter;
	DLL_BiGetStatus						BiGetStatus;
	DLL_BiGetInkStatus					BiGetInkStatus;
	DLL_BiGetPrnCapability				BiGetPrnCapability;

public:
	CInfo(void);
	virtual ~CInfo(void);

	int		Init(CProperty_1* pProperty);
	int		GetDeviceStatusFunction(CDeviceStatus* pDeviceStatus);
	int		GetInkStatusFunction(CInkStatus* pInkStatus);
	int		GetDeviceInfoFunction(CDeviceInfo* pDeviceInfo);
	int		GetMaintenanceCounterFunction(CMaintenanceCounter* pMaintenanceCounter);

private:
	void	GetAPIProcAddress(void);
};

#endif  /* !defined(SAMPLE_e974b440_a6a1_11e0_8264_0800200c9a66) */
