VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Scan"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Const BUZZER_COUNT_SUCCESS As Byte = 1
Private Const BUZZER_COUNT_ERROR As Byte = 2
Private Const BUUZER_COUNT_WFEED As Byte = 3

Private m_pCProperty As Property_1
Private m_mfBase As MF_BASE01
Private m_mfScanFront As MF_SCAN
Private m_mfScanBack As MF_SCAN

Private Sub Class_Initialize()

    If (m_pCProperty Is Nothing) Then
        Set m_pCProperty = New Property_1
    End If

End Sub

Public Sub SetProperty(ByRef pCProperty As Property_1)

    Set m_pCProperty = pCProperty

End Sub

'// Start scanning
Public Function ScanFunction() As Long

    Dim lResult As Long
    
    lResult = SUCCESS

    lResult = BiSCNMICRFunctionContinuously(m_pCProperty.GetHandle(), Nothing, MF_EXEC)

    ScanFunction = lResult

End Function

'// Set MF_BASE01 structure
Public Function SetBaseSetting() As Long
    
    Dim lResult As Long
    
    lResult = SUCCESS
    
    lResult = BiSCNSelectScanUnit(m_pCProperty.GetHandle(), m_pCProperty.GetScanMedia())
    If Not (lResult = SUCCESS) Then
    
        SetBaseSetting = lResult
        Exit Function
    
    End If
    
    lResult = FunctionContinuouslyBase(m_pCProperty.GetHandle(), m_mfBase, MF_GET_BASE_DEFAULT)
    If Not (lResult = SUCCESS) Then
    
        SetBaseSetting = lResult
        Exit Function
    
    End If
    
    Call CopyMemory(m_mfBase.iSize(1), CLng(LenB(m_mfBase)), 4)
    Call CopyMemory(m_mfBase.iVersion(1), MF_BASE_VERSION01, 4)
    Call CopyMemory(m_mfBase.wErrorEject(1), MF_EXIT_ERROR_DISCHARGE, 2)
    
    
    '// Set buzzer settings
    If (m_pCProperty.GetBuzzerSuccess() = True) Then
    
        Call CopyMemory(m_mfBase.bBuzzerCount(MF_BUZZER_TYPE_SUCCESS), BUZZER_COUNT_SUCCESS, 1)
        Call CopyMemory(m_mfBase.bBuzzerHz(MF_BUZZER_TYPE_SUCCESS), MF_BUZZER_HZ_4000, 1)
    
    Else
    
        Call CopyMemory(m_mfBase.bBuzzerCount(MF_BUZZER_TYPE_SUCCESS), MF_BUZZER_DISABLE, 1)
    
    End If

    If (m_pCProperty.GetBuzzerError() = True) Then
    
        Call CopyMemory(m_mfBase.bBuzzerCount(MF_BUZZER_TYPE_ERROR), BUZZER_COUNT_ERROR, 1)
        Call CopyMemory(m_mfBase.bBuzzerHz(MF_BUZZER_TYPE_ERROR), MF_BUZZER_HZ_880, 1)
    
    Else
    
        Call CopyMemory(m_mfBase.bBuzzerCount(MF_BUZZER_TYPE_ERROR), MF_BUZZER_DISABLE, 1)
    
    End If
    
    If (m_pCProperty.GetBuzzerDoubleFeed() = True) Then
    
        Call CopyMemory(m_mfBase.bBuzzerCount(MF_BUZZER_TYPE_WFEED), BUUZER_COUNT_WFEED, 1)
        Call CopyMemory(m_mfBase.bBuzzerHz(MF_BUZZER_TYPE_WFEED), MF_BUZZER_HZ_440, 1)
    
    Else
    
        Call CopyMemory(m_mfBase.bBuzzerCount(MF_BUZZER_TYPE_WFEED), MF_BUZZER_DISABLE, 1)
    
    End If

    lResult = FunctionContinuouslyBase(m_pCProperty.GetHandle(), m_mfBase, MF_SET_BASE_PARAM)
    
    Call m_pCProperty.SetMfBase01(m_mfBase)

    SetBaseSetting = lResult

End Function

'// Set scanning conditions
Public Function SetScanSetting() As Long

    Dim lResult As Long
    lResult = SUCCESS

    '// For front side image
    lResult = FunctionContinuouslyScan(m_pCProperty.GetHandle(), m_mfScanFront, MF_GET_SCAN_FRONT_DEFAULT)
    If Not (lResult = SUCCESS) Then
    
        SetScanSetting = lResult
        Exit Function
    
    End If

    Call CopyMemory(m_mfScanFront.iSize(1), CLng(LenB(m_mfScanFront)), 4)
    Call CopyMemory(m_mfScanFront.iVersion(1), MF_SCAN_VERSION, 4)
    Call CopyMemory(m_mfScanFront.sResolution(1), m_pCProperty.GetResolution(), 2)

    lResult = FunctionContinuouslyScan(m_pCProperty.GetHandle(), m_mfScanFront, MF_SET_SCAN_FRONT_PARAM)
    If Not (lResult = SUCCESS) Then
    
        SetScanSetting = lResult
        Exit Function
    
    End If
    
    Call m_pCProperty.SetMfScanFront(m_mfScanFront)

    lResult = BiSCNSelectScanFace(m_pCProperty.GetHandle(), MF_SCAN_FACE_FRONT)
    If Not (lResult = SUCCESS) Then
    
        SetScanSetting = lResult
        Exit Function
    
    End If

    lResult = BiSCNSetImageTypeOption(m_pCProperty.GetHandle(), m_pCProperty.GetImageChannel())
    If Not (lResult = SUCCESS) Then
    
        SetScanSetting = lResult
        Exit Function
    
    End If

    '// For back side image
    lResult = FunctionContinuouslyScan(m_pCProperty.GetHandle(), m_mfScanBack, MF_GET_SCAN_BACK_DEFAULT)
    If Not (lResult = SUCCESS) Then
    
        SetScanSetting = lResult
        Exit Function
    
    End If

    Call CopyMemory(m_mfScanBack.iSize(1), CLng(LenB(m_mfScanBack)), 4)
    Call CopyMemory(m_mfScanBack.iVersion(1), MF_SCAN_VERSION, 4)
    Call CopyMemory(m_mfScanBack.sResolution(1), m_pCProperty.GetResolution(), 2)

    lResult = FunctionContinuouslyScan(m_pCProperty.GetHandle(), m_mfScanBack, MF_SET_SCAN_BACK_PARAM)
    If Not (lResult = SUCCESS) Then
    
        SetScanSetting = lResult
        Exit Function
    
    End If
    
    Call m_pCProperty.SetMfScanBack(m_mfScanBack)

    lResult = BiSCNSelectScanFace(m_pCProperty.GetHandle(), MF_SCAN_FACE_BACK)
    If Not (lResult = SUCCESS) Then
    
        SetScanSetting = lResult
        Exit Function
    
    End If

    lResult = BiSCNSetImageTypeOption(m_pCProperty.GetHandle(), m_pCProperty.GetImageChannel())
    If Not (lResult = SUCCESS) Then
    
        SetScanSetting = lResult
        Exit Function
    
    End If

    SetScanSetting = lResult

End Function

'// Scanning cancellation
Public Function CancelScan() As Long

 CancelScan = BiSCNMICRCancelFunction(m_pCProperty.GetHandle(), MF_EJECT_DISCHARGE)

End Function


