Imports System.Diagnostics
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace TMS_Sample
	Public Partial Class ConfigureForm
		Inherits Form
		Private m_objConfigData As StructByStep = Nothing

		Public Sub New()
			InitializeComponent()

			m_objConfigData = New StructByStep()
		End Sub

		Private Sub ConfigureForm_Load(sender As Object, e As EventArgs)
			LoadResourceString()

			SetControlData()

			UpdateControls()
		End Sub

		Public Sub SetConfigData(objConfigData As StructByStep)
			m_objConfigData.Copy(objConfigData)
		End Sub

		Public Sub GetConfigData(ByRef objConfigData As StructByStep)
			If objConfigData IsNot Nothing Then
				objConfigData.Copy(m_objConfigData)
			End If
		End Sub

		Private Sub LoadResourceString()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			btnOK.Text = ConstComStr.STR_CONFIGDLG_BUTTON_OK
			btnCancel.Text = ConstComStr.STR_CONFIGDLG_BUTTON_CANCEL

			stGroupScanning.Text = ConstComStr.STR_CONFIGDLG_GROUP_SCANNING
			stGroupScanningMedia.Text = ConstComStr.STR_CONFIGDLG_GROUP_SCANNINGMEDIA
			stGroupLightSource.Text = ConstComStr.STR_CONFIGDLG_GROUP_LIGHTSOURCE
			stGroupRGBColorDepth.Text = ConstComStr.STR_CONFIGDLG_GROUP_RGBCOLORDEPTH
			stGroupIRColorDepth.Text = ConstComStr.STR_CONFIGDLG_GROUP_IRCOLORDEPTH

			stResolution.Text = ConstComStr.STR_CONFIGDLG_STATIC_RESOLUTION

			btnRadioSMCheckPaper.Text = ConstComStr.STR_CONFIGDLG_RADIO_SM_CHECKPAPER
			btnRadioSMCard.Text = ConstComStr.STR_CONFIGDLG_RADIO_SM_CARD
			btnRadioICRGB.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGB
			btnRadioICIR.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_IR
			btnRadioICRGBIR.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGBIR
			btnRadioCDRColor.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_COLOR
			btnRadioCDRGray.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_GRAY
			btnRadioCDRBW.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_BW
			btnRadioCDIGray.Text = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_GRAY
			btnRadioCDIBW.Text = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_BW
			btnCheckSCSaveFile.Text = ConstComStr.STR_CONFIGDLG_CHECK_SC_SAVEFILE

			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100)
		End Sub

		Private Sub SetControlData()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			Select Case m_objConfigData.nRadio_ScanningMedia
				Case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER
					btnRadioSMCheckPaper.Checked = True
					btnRadioSMCard.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD
					btnRadioSMCheckPaper.Checked = False
					btnRadioSMCard.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select

			Select Case m_objConfigData.nRadio_LightSourceToScan
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB
					btnRadioICRGB.Checked = True
					btnRadioICIR.Checked = False
					btnRadioICRGBIR.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR
					btnRadioICRGB.Checked = False
					btnRadioICIR.Checked = True
					btnRadioICRGBIR.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR
					btnRadioICRGB.Checked = False
					btnRadioICIR.Checked = False
					btnRadioICRGBIR.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select
			Select Case m_objConfigData.nRadio_RGBColorDepth
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR
					btnRadioCDRColor.Checked = True
					btnRadioCDRGray.Checked = False
					btnRadioCDRBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY
					btnRadioCDRColor.Checked = False
					btnRadioCDRGray.Checked = True
					btnRadioCDRBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW
					btnRadioCDRColor.Checked = False
					btnRadioCDRGray.Checked = False
					btnRadioCDRBW.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select
			Select Case m_objConfigData.nRadio_IRColorDepth
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY
					btnRadioCDIGray.Checked = True
					btnRadioCDIBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW
					btnRadioCDIGray.Checked = False
					btnRadioCDIBW.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select

			SetIndexResolutionCombobox(m_objConfigData.nCombo_Resolution)

			udNumberOfDocuments.Minimum = 0
			udNumberOfDocuments.Maximum = 255
			udNumberOfDocuments.Value = Convert.ToDecimal(m_objConfigData.byNumeric_NumberOfDocuments)

			btnCheckSCSaveFile.Checked = m_objConfigData.bCheck_Scan_SaveFile
		End Sub

		Private Sub GetControlData()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			If btnRadioSMCheckPaper.Checked = True Then
				m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER
			ElseIf btnRadioSMCard.Checked = True Then
				m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD
			End If

			If btnRadioICRGB.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB
			ElseIf btnRadioICIR.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR
			ElseIf btnRadioICRGBIR.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR
			End If

			If btnRadioCDRColor.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR
			ElseIf btnRadioCDRGray.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY
			ElseIf btnRadioCDRBW.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW
			End If

			If btnRadioCDIGray.Checked = True Then
				m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY
			ElseIf btnRadioCDIBW.Checked = True Then
				m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW
			End If

			m_objConfigData.nCombo_Resolution = GetValueResolutionCombobox()

			m_objConfigData.byNumeric_NumberOfDocuments = Convert.ToByte(udNumberOfDocuments.Value)

			m_objConfigData.bCheck_Scan_SaveFile = btnCheckSCSaveFile.Checked
		End Sub

		Private Sub UpdateControls()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			' LightSource
			If btnRadioSMCard.Checked = True AndAlso m_objConfigData.bIsScanningCardIR1PassSupported = False Then
				btnRadioICRGBIR.Enabled = False

				If btnRadioICRGBIR.Checked = True Then
					btnRadioICIR.Checked = True
					btnRadioICRGBIR.Checked = False
				End If
			Else
				btnRadioICRGBIR.Enabled = True
			End If

			' RGB ColorDepth Color
			If btnRadioICIR.Checked = True Then
				btnRadioCDRColor.Enabled = False
			Else
				btnRadioCDRColor.Enabled = True
			End If

			' RGB ColorDepth Gray
			If btnRadioICIR.Checked = True Then
				btnRadioCDRGray.Enabled = False
			Else
				btnRadioCDRGray.Enabled = True
			End If

			' RGB ColorDepth B/W
			If btnRadioICIR.Checked = True OrElse btnRadioSMCard.Checked = True Then
				btnRadioCDRBW.Enabled = False
			Else
				btnRadioCDRBW.Enabled = True
			End If

			' IR ColorDepth Gray
			If btnRadioICRGB.Checked = True Then
				btnRadioCDIGray.Enabled = False
			Else
				btnRadioCDIGray.Enabled = True
			End If

			' IR ColorDepth B/W
			If btnRadioICRGB.Checked = True OrElse btnRadioSMCard.Checked = True Then
				btnRadioCDIBW.Enabled = False
			Else
				btnRadioCDIBW.Enabled = True
			End If

			If btnRadioCDRBW.Checked = True AndAlso btnRadioCDRGray.Enabled.Equals(True) AndAlso Not btnRadioCDRBW.Enabled.Equals(True) Then
				btnRadioCDRColor.Checked = False
				btnRadioCDRGray.Checked = True
				btnRadioCDRBW.Checked = False
			End If
			If btnRadioCDIBW.Checked = True AndAlso btnRadioCDIGray.Enabled.Equals(True) AndAlso Not btnRadioCDIBW.Enabled.Equals(True) Then
				btnRadioCDIGray.Checked = True
				btnRadioCDIBW.Checked = False
			End If

			' Updating resolution options for scanning unit
			Dim strResolution As String = cmbResolution.Text
			If btnRadioSMCheckPaper.Checked = True Then
				cmbResolution.Items.Clear()
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100)
				cmbResolution.SelectedIndex = 2
			ElseIf btnRadioSMCard.Checked = True Then
				cmbResolution.Items.Clear()
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
				cmbResolution.SelectedIndex = 1
			Else
				Debug.Assert(False)
			End If
			' restore the selection.
			Dim nIndex As Integer = cmbResolution.FindString(strResolution)
			If nIndex <> -1 Then
				cmbResolution.SelectedIndex = nIndex
			End If
		End Sub

		'''/////////////
		'''/ Step 2 ////
		'''/////////////

		Private Sub btnOK_Click(sender As Object, e As EventArgs)
			GetControlData()
			Close()
		End Sub

		Private Sub btnCancel_Click(sender As Object, e As EventArgs)
			Close()
		End Sub

		Private Sub OnChangeRadioScanningMedia(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub OnChangeRadioLightSource(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		'''/////////////
		'''/ Step 2 ////
		'''/////////////

		Private Sub SetIndexResolutionCombobox(nResolution As Integer)
			Dim strResolution As String = ""
			Select Case nResolution
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_600600
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_600600
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_300300
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_300300
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_240240
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_240240
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_200200
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_120120
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_120120
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_100100
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_100100
					Exit Select
				Case Else
					Debug.Assert(False)
					Return
			End Select
			Dim nIndex As Integer = cmbResolution.FindString(strResolution)
			If nIndex <> -1 Then
				cmbResolution.SelectedIndex = nIndex
			Else
				cmbResolution.SelectedIndex = 0
			End If
		End Sub

		Private Function GetValueResolutionCombobox() As Integer
			Select Case cmbResolution.SelectedItem.ToString()
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_600600
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_600600
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_300300
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_300300
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_240240
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_240240
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_200200
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_120120
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_120120
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_100100
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_100100
				Case Else
					Debug.Assert(False)
					Return -1
			End Select
		End Function
	End Class
End Namespace
