Imports System.Diagnostics
Imports System.Text
Imports com.epson.bank.driver

Namespace TMS_Sample
	Class CPrint
		Private Const TRANS_NO_SPECIFIED As UInteger = &H40000000
		Private m_objProperty As CProperty_1 = Nothing

		Public Sub New()
		End Sub

		Public Function Init(objProperty As CProperty_1) As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			m_objProperty = objProperty

			Return errResult
		End Function

		' Print on roll paper
		Public Function PrintRollpaper() As ErrorCode
			' S9000 only
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			' Set printing unit to roll paper
			errResult = m_objProperty.GetMfDevice().SetPrintStation(PrintingStation.MF_ST_ROLLPAPER)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Start print data buffering
			errResult = m_objProperty.GetMfDevice().BufferedPrint(PrintBuffer.MF_PRT_BUFFERING)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set image data for printing
			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_CENTER)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SetPrintSize(65, 15)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintImage("Logo.bmp")
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set printing text
			Dim mfDecorate As New MFDeviceFont()
			Dim szRollPaper As String = Nothing
			Dim sbRollPaper As New StringBuilder()
			Dim stDateTime As DateTime

			mfDecorate.Font = FontType.MF_PRINT_FONT_B
			mfDecorate.Size = FontScale.MF_PRINT_FONT_W1_H1
			mfDecorate.Underline = UnderlineType.MF_PRINT_NO_UNDERLINE
			mfDecorate.Color = PrintColor.MF_PRINT_BLACK

			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_RIGHT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			sbRollPaper.Append(vbCr & vbLf & vbCr & vbLf & "600 Grant Street Pittsburgh, PA 15219" & vbCr & vbLf)
			sbRollPaper.Append("Phone: (555)555-5555" & vbCr & vbLf & vbCr & vbLf & vbCr & vbLf)
			szRollPaper = sbRollPaper.ToString()
			sbRollPaper.Length = 0

			errResult = m_objProperty.GetMfDevice().PrintText(szRollPaper, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			mfDecorate.Font = FontType.MF_PRINT_FONT_A
			stDateTime = DateTime.Now

			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_LEFT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			sbRollPaper.Append("Station S1             Teller 0001 Seq# 02" & vbCr & vbLf)
			sbRollPaper.Append(stDateTime.Day.ToString("00") & "/" & stDateTime.Month.ToString("00") & "/" & stDateTime.Year.ToString("00") & "                         " & stDateTime.Hour.ToString("00") & ":" & stDateTime.Minute.ToString("00") & ":" & stDateTime.Second.ToString("00") & vbCr & vbLf & vbCr & vbLf)
			szRollPaper = sbRollPaper.ToString()
			sbRollPaper.Length = 0

			errResult = m_objProperty.GetMfDevice().PrintText(szRollPaper, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_CENTER)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintText("Deposit Transaction Receipt" & vbCr & vbLf & vbCr & vbLf, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			mfDecorate.Underline = UnderlineType.MF_PRINT_UNDERLINE_1

			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_LEFT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintText("Deposit Ticket                   Amount($)" & vbCr & vbLf, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			mfDecorate.Underline = UnderlineType.MF_PRINT_NO_UNDERLINE

			errResult = m_objProperty.GetMfDevice().PrintText("Account #1234567890               1,000.00" & vbCr & vbLf & vbCr & vbLf, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			mfDecorate.Underline = UnderlineType.MF_PRINT_UNDERLINE_1

			errResult = m_objProperty.GetMfDevice().PrintText("Demosited Items                  Amount($)" & vbCr & vbLf, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			mfDecorate.Underline = UnderlineType.MF_PRINT_NO_UNDERLINE

			sbRollPaper.Append("Personal Check" & vbCr & vbLf)
			sbRollPaper.Append("1234567890-1541                   1,000.00" & vbCr & vbLf & vbCr & vbLf)
			szRollPaper = sbRollPaper.ToString()
			sbRollPaper.Length = 0

			errResult = m_objProperty.GetMfDevice().PrintText(szRollPaper, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_RIGHT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintText("---------" & vbCr & vbLf, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_LEFT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintText("Total:                            1,000.0" & vbCr & vbLf, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_CENTER)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintText("Successful Deposit Transaction." & vbLf & vbCr & vbCr & vbLf, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set printing barcode
			errResult = m_objProperty.GetMfDevice().SetPrintAlignment(Alignment.MF_PRINT_ALIGNMENT_CENTER)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SetPrintSize(30, 15)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Dim byBarcode As Byte() = Encoding.UTF8.GetBytes("123456789")

			errResult = m_objProperty.GetMfDevice().PrintBarCode(byBarcode, Symbol.CODE_CODE39, TextPosition.HRI_BELOW)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			byBarcode = Encoding.UTF8.GetBytes("EXCEED YOUR VISION EXCEED YOUR VISION EXCEED YOUR VISION EXCEED YOUR VISION EXCEED YOUR VISION")
			errResult = m_objProperty.GetMfDevice().PrintBarCode(byBarcode, Symbol.CODE_PDF417, TextPosition.HRI_NONE)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			'Auto cut
			errResult = m_objProperty.GetMfDevice().AutoCutRollPaper(AutoCutType.AUTOCUT_FEEDANDCUT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' print buffered printing data
			errResult = m_objProperty.GetMfDevice().BufferedPrint(PrintBuffer.MF_PRT_EXEC)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		' Print on cut sheet paper
		Public Function PrintReceipt() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS
			Dim nLoadNum As Integer = 0
			Dim sbPath As New StringBuilder()
			Dim szPath As String = Nothing

			' Set printing unit to cut sheet paper
			errResult = m_objProperty.GetMfDevice().SetPrintStation(PrintingStation.MF_ST_FEEDER)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Load print information file for template printing
			sbPath.Append(System.IO.Directory.GetCurrentDirectory())
			sbPath.Append("\FormatSettingStep5.ini")
			szPath = sbPath.ToString()

			errResult = m_objProperty.GetMfDevice().LoadTemplatePrintArea(szPath, nLoadNum)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SetPrintCutSheetSettings(1, ScanEnable.BI_PRINTCUTSHEET_NOSCAN)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintCutSheet(m_objProperty.GetMfBase(), FunctionType.MF_GET_BASE_DEFAULT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintCutSheet(m_objProperty.GetMfBase(), FunctionType.MF_SET_BASE_PARAM)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintCutSheet(FunctionType.MF_EXEC)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		' Set contents of cut sheet paper printing
		Public Function PrintReceiptFunction(nTransactionNumber As Integer) As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			' Start buffering of print data for template printing
			errResult = m_objProperty.GetMfDevice().TemplatePrint(TemplatePrintMode.TEMPLATEPRINT_BUFFERING)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set image data for printing
			errResult = m_objProperty.GetMfDevice().SetTemplatePrintArea(AreaSelectMode.SELECTPRINTAREA_AREANAME, "ReceiptLogo", Nothing, TRANS_NO_SPECIFIED)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintImage("ReceiptImage.bmp")
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set print text
			errResult = m_objProperty.GetMfDevice().SetTemplatePrintArea(AreaSelectMode.SELECTPRINTAREA_AREANAME, "ReceiptText", Nothing, TRANS_NO_SPECIFIED)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Dim stDateTime As DateTime
			Dim mfDecorate As New MFDeviceFont()
			Dim szReceipt As String = Nothing
			Dim sbReceipt As New StringBuilder()
			Dim szWeek As String() = New String() {"", "Sun", "Mon", "Tue", "Wed", "Thu", _
				"Fri", "Sat"}

			stDateTime = DateTime.Now
			sbReceipt.Append(stDateTime.Day.ToString("00") & "/" & stDateTime.Month.ToString("00") & "/" & stDateTime.Year.ToString("0000") & " " & szWeek(CInt(stDateTime.DayOfWeek)) & " " & stDateTime.Hour.ToString("00") & ":" & stDateTime.Minute.ToString("00") & ":" & stDateTime.Second.ToString("00") & ":" & stDateTime.Millisecond.ToString() & vbCr & vbLf)
			sbReceipt.Append("nTran #" & nTransactionNumber.ToString("00000") & vbCr & vbLf)
			sbReceipt.Append("nEntity NCS CC 9999999 Tlr 99999" & vbCr & vbLf)
			sbReceipt.Append("Acct Type SAV" & vbCr & vbLf)
			sbReceipt.Append("Available Balance" & vbCr & vbTab & "2000.00" & vbCr & vbLf)
			szReceipt = sbReceipt.ToString()

			errResult = m_objProperty.GetMfDevice().PrintText(szReceipt, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Print buffered printing data
			errResult = m_objProperty.GetMfDevice().TemplatePrint(TemplatePrintMode.TEMPLATEPRINT_EXEC)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		' Set contents of cashiers check printing
		Public Function SetCashierscheckPrintSetting() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS
			Dim nLoadNum As Integer = 0
			Dim sbPath As New StringBuilder()
			Dim szPath As String = Nothing

			' Set printing unit to cut sheet paper
			errResult = m_objProperty.GetMfDevice().SetPrintStation(PrintingStation.MF_ST_FEEDER)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Load print information file for template printing
			sbPath.Append(System.IO.Directory.GetCurrentDirectory())
			sbPath.Append("\FormatSettingStep5.ini")
			szPath = sbPath.ToString()

			errResult = m_objProperty.GetMfDevice().LoadTemplatePrintArea(szPath, nLoadNum)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SetPrintCutSheetSettings(m_objProperty.GetPrintingNumber(), m_objProperty.GetAfterScanning())
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		' Set MF_SCAN structure for cashiers check printing
		Public Function SetCashierscheckScanSetting() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			errResult = m_objProperty.GetMfDevice().SCNSelectScanUnit(ScanUnit.EPS_BI_SCN_UNIT_CHECKPAPER)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SCNSelectScanFace(ScanSide.MF_SCAN_FACE_FRONT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SCNSetImageTypeOption(ImageTypeOption.EPS_BI_SCN_OPTION_COLOR)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SCNSelectScanFace(ScanSide.MF_SCAN_FACE_BACK)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().SCNSetImageTypeOption(ImageTypeOption.EPS_BI_SCN_OPTION_COLOR)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set scanning setting for printed side
			errResult = m_objProperty.GetMfDevice().PrintCutSheet(m_objProperty.GetMfScanFront(), FunctionType.MF_GET_SCAN_PRINTAREA_DEFAULT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintCutSheet(m_objProperty.GetMfScanFront(), FunctionType.MF_SET_SCAN_PRINTAREA_PARAM)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set scanning setting for reverse side
			errResult = m_objProperty.GetMfDevice().PrintCutSheet(m_objProperty.GetMfScanBack(), FunctionType.MF_GET_SCAN_NOPRINTAREA_DEFAULT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintCutSheet(m_objProperty.GetMfScanBack(), FunctionType.MF_SET_SCAN_NOPRINTAREA_PARAM)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		' Set MF_BASE structure for cashiers check printing
		Public Function SetCashierscheckBaseSetting() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			errResult = m_objProperty.GetMfDevice().PrintCutSheet(m_objProperty.GetMfBase(), FunctionType.MF_GET_BASE_DEFAULT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintCutSheet(m_objProperty.GetMfBase(), FunctionType.MF_SET_BASE_PARAM)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		' Perform cashiers check printing
		Public Function PrintCashierscheck() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			errResult = m_objProperty.GetMfDevice().PrintCutSheet(FunctionType.MF_EXEC)
			Debug.Assert(errResult = ErrorCode.SUCCESS)

			Return errResult
		End Function

		' Set contents of cashiers check printing
		Public Function PrintCashierscheckFunction() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			' Start buffering of print data for template printing
			errResult = m_objProperty.GetMfDevice().TemplatePrint(TemplatePrintMode.TEMPLATEPRINT_BUFFERING)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set image data for printing
			errResult = m_objProperty.GetMfDevice().SetTemplatePrintArea(AreaSelectMode.SELECTPRINTAREA_AREANAME, "CashiersSignature", Nothing, TRANS_NO_SPECIFIED)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintImage("CashiersSign.bmp")
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Set print text
			Dim stDateTime As DateTime
			Dim mfDecorate As New MFDeviceFont()
			Dim szCashierscheck As String = Nothing
			Dim sbCashierscheck As New StringBuilder()
			Dim szMonth As String() = New String() {"", "Jan", "Feb", "Mar", "Apr", "May", _
				"Jun", "Jul", "Aug", "Sep", "Oct", "Nov", _
				"Dec"}

			'Date

			stDateTime = DateTime.Now
			mfDecorate.Underline = UnderlineType.MF_PRINT_NO_UNDERLINE
			mfDecorate.Font = FontType.MF_PRINT_FONT_A
			mfDecorate.Size = FontScale.MF_PRINT_FONT_W1_H1

			errResult = m_objProperty.GetMfDevice().SetTemplatePrintArea(AreaSelectMode.SELECTPRINTAREA_AREANAME, "CashiersDate", Nothing, TRANS_NO_SPECIFIED)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			sbCashierscheck.Append(szMonth(stDateTime.Month) & " " & stDateTime.Day.ToString("00") & "," & stDateTime.Year.ToString("0000"))
			szCashierscheck = sbCashierscheck.ToString()
			sbCashierscheck.Length = 0

			errResult = m_objProperty.GetMfDevice().PrintText(szCashierscheck, mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			'Name

			mfDecorate.Size = FontScale.MF_PRINT_FONT_W2_H1

			errResult = m_objProperty.GetMfDevice().SetTemplatePrintArea(AreaSelectMode.SELECTPRINTAREA_AREANAME, "CashiersName", Nothing, TRANS_NO_SPECIFIED)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintText("Taro Nanashi", mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			'OrderNum

			errResult = m_objProperty.GetMfDevice().SetTemplatePrintArea(AreaSelectMode.SELECTPRINTAREA_AREANAME, "CashiersOrderString", Nothing, TRANS_NO_SPECIFIED)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().PrintText("Two thousand five hundred and 00 Cents", mfDecorate)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Print buffered printing data
			errResult = m_objProperty.GetMfDevice().TemplatePrint(TemplatePrintMode.TEMPLATEPRINT_EXEC)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		' Check if the roll paper is supported as print station.
		Public Function IsRollPaperSupported() As Boolean
			Dim errResult As ErrorCode = ErrorCode.SUCCESS
			errResult = m_objProperty.GetMfDevice().SetPrintStation(PrintingStation.MF_ST_ROLLPAPER)
			If errResult = ErrorCode.SUCCESS Then
				Return True
			Else
				Return False
			End If
		End Function
	End Class
End Namespace
