Imports System.Diagnostics
Imports com.epson.bank.driver

Namespace TMS_Sample
	Class COcrAB
		Private Const OCR_AB_START_X As Integer = 30
		Private Const OCR_AB_START_Y As Integer = 56
		Private Const OCR_AB_END_X As Integer = 110
		Private Const OCR_AB_END_Y As Integer = 70

		Private m_objProperty As CProperty_1 = Nothing

		Public Sub New()
		End Sub

		Public Function Init(objProperty As CProperty_1) As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS
			m_objProperty = objProperty

			Return errResult
		End Function

		Public Function SetOcrABSetting() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			m_objProperty.GetMfOcrAB().OcrType = m_objProperty.GetOcrABFont()
			m_objProperty.GetMfOcrAB().Direction = MfDirection.MF_OCR_LEFTRIGHT
			m_objProperty.GetMfOcrAB().SpeceHandling = MfSpeceHandling.OCR_SPACE_ENABLE
			m_objProperty.GetMfOcrAB().StartX = OCR_AB_START_X
			m_objProperty.GetMfOcrAB().StartY = OCR_AB_START_Y
			m_objProperty.GetMfOcrAB().EndX = OCR_AB_END_X
			m_objProperty.GetMfOcrAB().EndY = OCR_AB_END_Y

			Return errResult
		End Function

		Public Function GetOcrABFunction(ByRef objOcrABResult As COcrABResult) As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			If objOcrABResult Is Nothing Then
				Return ErrorCode.ERR_PARAM
			End If

			errResult = m_objProperty.GetMfDevice().SCNSelectScanFace(ScanSide.MF_SCAN_FACE_FRONT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().GetOcrABText(CUInt(m_objProperty.GetTransactionNumber()), OcrImageSource.OCR_SOURCE_TRANSACTION_NUMBER, "", m_objProperty.GetMfOcrAB())
			Debug.Assert(errResult = ErrorCode.SUCCESS OrElse errResult = ErrorCode.ERR_MICR_NODATA)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			objOcrABResult.SetTransactionNumber(m_objProperty.GetTransactionNumber())
			objOcrABResult.SetResult(m_objProperty.GetMfOcrAB().Ret)
			objOcrABResult.SetOcrStr(m_objProperty.GetMfOcrAB().OcrStr)
			objOcrABResult.SetOcrReliableInfo(m_objProperty.GetMfOcrAB().OcrReliableInfo)

			Return errResult
		End Function
	End Class
End Namespace
