Imports System.Diagnostics
Imports System.Text
Imports com.epson.bank.driver

Namespace TMS_Sample
	Class CBarcode
		Private m_objProperty As CProperty_1 = Nothing

		Public Sub New()
		End Sub

		Public Function Init(objProperty As CProperty_1) As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS
			m_objProperty = objProperty

			Return errResult
		End Function

		Public Function SetBarcodeSetting() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			' Settings for front side
			errResult = m_objProperty.GetMfDevice().SCNMICRFunctionContinuously(m_objProperty.GetMfBarcodeFront(), FunctionType.MF_GET_BARCODE_FRONT_DEFAULT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			' Specify barcode symbols to be decoded
			m_objProperty.GetMfBarcodeFront().Info(0).SymbolMask = m_objProperty.GetBarcodeTypeMask()

			' Barcode detection error
			m_objProperty.GetMfBarcodeFront().ErrorSelect = m_objProperty.GetBarcodeDetect()
			If m_objProperty.GetBarcodeDetect() = MfErrorSelect.MF_ERROR_SELECT_DETECT Then
				m_objProperty.GetMfBarcodeFront().ErrorEject = m_objProperty.GetBarcodeEject()
				m_objProperty.GetMfBarcodeFront().Cancel = m_objProperty.GetBarcodeCancel()
			End If

			errResult = m_objProperty.GetMfDevice().SCNMICRFunctionContinuously(m_objProperty.GetMfBarcodeFront(), FunctionType.MF_SET_BARCODE_FRONT_PARAM)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		Public Function GetBarcode(ByRef objBarcodeResult As CBarcodeResult) As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS
			If objBarcodeResult Is Nothing Then
				Return ErrorCode.ERR_UNKNOWN
			End If

			errResult = m_objProperty.GetMfDevice().SCNSelectScanFace(ScanSide.MF_SCAN_FACE_FRONT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			errResult = m_objProperty.GetMfDevice().GetBarcodeData(m_objProperty.GetTransactionNumber(), m_objProperty.GetMfBarcodeFront())
			Debug.Assert(errResult = ErrorCode.SUCCESS OrElse errResult = ErrorCode.ERR_BARCODE_NODATA)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			If m_objProperty.GetMfBarcodeFront().Data IsNot Nothing Then
				Dim strBarcodeCombined As String = ""
				Dim BarcodeData As MFBarcode.BarcodeData() = m_objProperty.GetMfBarcodeFront().Data
				Dim nCount As Integer = BarcodeData.Length
				For nIndex As Integer = 0 To nCount - 1
					' MFBarcode.BarcodeData.Data must include null terminator.
					' Chop null terminator by shrinking length.
					Dim strBarcode As String = Encoding.ASCII.GetString(BarcodeData(nIndex).Data, 0, BarcodeData(nIndex).Data.Length - 1)

					' And also, CODE-128 may include null character. Replace it to show on the screen.
					strBarcode = strBarcode.Replace(ControlChars.NullChar, " "C)

					If strBarcodeCombined.Length = 0 Then
						strBarcodeCombined = strBarcode
					Else
						strBarcodeCombined += " "
						strBarcodeCombined += strBarcode
					End If
				Next
				objBarcodeResult.SetBarcodeData(strBarcodeCombined)
			Else
				objBarcodeResult.SetBarcodeData("")
			End If

			Return errResult
		End Function
	End Class
End Namespace

