Imports System.Diagnostics
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace TMS_Sample
	Public Partial Class ConfigureForm
		Inherits Form
		Private m_objConfigData As StructByStep = Nothing

		Public Sub New()
			InitializeComponent()

			m_objConfigData = New StructByStep()
		End Sub

		Private Sub ConfigureForm_Load(sender As Object, e As EventArgs)
			LoadResourceString()

			SetControlData()

			UpdateControls()
		End Sub

		Public Sub SetConfigData(objConfigData As StructByStep)
			m_objConfigData.Copy(objConfigData)
		End Sub

		Public Sub GetConfigData(ByRef objConfigData As StructByStep)
			If objConfigData IsNot Nothing Then
				objConfigData.Copy(m_objConfigData)
			End If
		End Sub

		Private Sub LoadResourceString()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			btnOK.Text = ConstComStr.STR_CONFIGDLG_BUTTON_OK
			btnCancel.Text = ConstComStr.STR_CONFIGDLG_BUTTON_CANCEL

			stGroupScanning.Text = ConstComStr.STR_CONFIGDLG_GROUP_SCANNING
			stGroupScanningMedia.Text = ConstComStr.STR_CONFIGDLG_GROUP_SCANNINGMEDIA
			stGroupLightSource.Text = ConstComStr.STR_CONFIGDLG_GROUP_LIGHTSOURCE
			stGroupRGBColorDepth.Text = ConstComStr.STR_CONFIGDLG_GROUP_RGBCOLORDEPTH
			stGroupIRColorDepth.Text = ConstComStr.STR_CONFIGDLG_GROUP_IRCOLORDEPTH

			stResolution.Text = ConstComStr.STR_CONFIGDLG_STATIC_RESOLUTION

			btnRadioSMCheckPaper.Text = ConstComStr.STR_CONFIGDLG_RADIO_SM_CHECKPAPER
			btnRadioSMCard.Text = ConstComStr.STR_CONFIGDLG_RADIO_SM_CARD
			btnRadioICRGB.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGB
			btnRadioICIR.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_IR
			btnRadioICRGBIR.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGBIR
			btnRadioCDRColor.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_COLOR
			btnRadioCDRGray.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_GRAY
			btnRadioCDRBW.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_BW
			btnRadioCDIGray.Text = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_GRAY
			btnRadioCDIBW.Text = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_BW
			btnCheckSCSaveFile.Text = ConstComStr.STR_CONFIGDLG_CHECK_SC_SAVEFILE

			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100)

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			stGroupMICR.Text = ConstComStr.STR_CONFIGDLG_GROUP_MICR
			stGroupMICRFont.Text = ConstComStr.STR_CONFIGDLG_GROUP_MICRFONT

			btnRadioMFE13B.Text = ConstComStr.STR_CONFIGDLG_RADIO_MF_E13B
			btnRadioMFCMC7.Text = ConstComStr.STR_CONFIGDLG_RADIO_MF_CMC7

			btnCheckMIClearSpace.Text = ConstComStr.STR_CONFIGDLG_CHECK_MI_CLEARSPACE
			btnCheckMISaveFile.Text = ConstComStr.STR_CONFIGDLG_CHECK_MI_SAVEFILE

			'''/////////////
			'''/ Step 8 ////
			'''/////////////

			stGroupError.Text = ConstComStr.STR_CONFIGDLG_GROUP_ERROR
			stGroupPaperInsertion.Text = ConstComStr.STR_CONFIGDLG_GROUP_PAPERINSERTION
			stGroupNoise.Text = ConstComStr.STR_CONFIGDLG_GROUP_NOISE
			stGroupDoubleFeed.Text = ConstComStr.STR_CONFIGDLG_GROUP_DOUBLEFEED
			stGroupBadData.Text = ConstComStr.STR_CONFIGDLG_GROUP_BADDATA
			stGroupNoData.Text = ConstComStr.STR_CONFIGDLG_GROUP_NODATA
			stGroupBarcode.Text = ConstComStr.STR_CONFIGDLG_GROUP_BARCODE

			btnCheckPIDetect.Text = ConstComStr.STR_CONFIGDLG_CHECK_PI_DETECT
			btnCheckPICancel.Text = ConstComStr.STR_CONFIGDLG_CHECK_PI_CANCEL
			btnCheckNODetect.Text = ConstComStr.STR_CONFIGDLG_CHECK_NO_DETECT
			btnCheckNOCancel.Text = ConstComStr.STR_CONFIGDLG_CHECK_NO_CANCEL
			btnCheckDFDetect.Text = ConstComStr.STR_CONFIGDLG_CHECK_DF_DETECT
			btnCheckDFCancel.Text = ConstComStr.STR_CONFIGDLG_CHECK_DF_CANCEL
			btnCheckBDDetect.Text = ConstComStr.STR_CONFIGDLG_CHECK_BD_DETECT
			btnCheckBDCancel.Text = ConstComStr.STR_CONFIGDLG_CHECK_BD_CANCEL
			btnCheckNDDetect.Text = ConstComStr.STR_CONFIGDLG_CHECK_ND_DETECT
			btnCheckNDCancel.Text = ConstComStr.STR_CONFIGDLG_CHECK_ND_CANCEL
			btnCheckBADetect.Text = ConstComStr.STR_CONFIGDLG_CHECK_BA_DETECT
			btnCheckBACancel.Text = ConstComStr.STR_CONFIGDLG_CHECK_BA_CANCEL

			stPIEjectPocket.Text = ConstComStr.STR_CONFIGDLG_STATIC_PI_EJECTPOCKET
			stNOEjectPocket.Text = ConstComStr.STR_CONFIGDLG_STATIC_NO_EJECTPOCKET
			stDFEjectPocket.Text = ConstComStr.STR_CONFIGDLG_STATIC_DF_EJECTPOCKET
			stBDEjectPocket.Text = ConstComStr.STR_CONFIGDLG_STATIC_BD_EJECTPOCKET
			stNDEjectPocket.Text = ConstComStr.STR_CONFIGDLG_STATIC_ND_EJECTPOCKET
			stBAEjectPocket.Text = ConstComStr.STR_CONFIGDLG_STATIC_BA_EJECTPOCKET

			cmbPIEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_PI_EJ_MAINPOCKET)
			cmbPIEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_PI_EJ_SUBPOCKET)
			cmbNOEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_NO_EJ_MAINPOCKET)
			cmbNOEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_NO_EJ_SUBPOCKET)
			cmbDFEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_DF_EJ_MAINPOCKET)
			cmbDFEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_DF_EJ_SUBPOCKET)
			cmbBDEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_BD_EJ_MAINPOCKET)
			cmbBDEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_BD_EJ_SUBPOCKET)
			cmbNDEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_ND_EJ_MAINPOCKET)
			cmbNDEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_ND_EJ_SUBPOCKET)
			cmbBAEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_BA_EJ_MAINPOCKET)
			cmbBAEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_BA_EJ_SUBPOCKET)

			'''/////////////
			'''/ Step 8 ////
			'''/////////////

			lstBarcodeType.Items.Add(ConstComStr.STR_CONFIGDLG_LIST_BARCODE_SYMBOL_CODABAR)
			lstBarcodeType.Items.Add(ConstComStr.STR_CONFIGDLG_LIST_BARCODE_SYMBOL_CODE128)
			lstBarcodeType.Items.Add(ConstComStr.STR_CONFIGDLG_LIST_BARCODE_SYMBOL_CODE39)
			lstBarcodeType.Items.Add(ConstComStr.STR_CONFIGDLG_LIST_BARCODE_SYMBOL_ITF)
			lstBarcodeType.Items.Add(ConstComStr.STR_CONFIGDLG_LIST_BARCODE_SYMBOL_EAN_JAN)
			lstBarcodeType.Items.Add(ConstComStr.STR_CONFIGDLG_LIST_BARCODE_SYMBOL_UPC_A)
			lstBarcodeType.Items.Add(ConstComStr.STR_CONFIGDLG_LIST_BARCODE_SYMBOL_UPC_E)
		End Sub

		Private Sub SetControlData()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			Select Case m_objConfigData.nRadio_ScanningMedia
				Case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER
					btnRadioSMCheckPaper.Checked = True
					btnRadioSMCard.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD
					btnRadioSMCheckPaper.Checked = False
					btnRadioSMCard.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select

			Select Case m_objConfigData.nRadio_LightSourceToScan
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB
					btnRadioICRGB.Checked = True
					btnRadioICIR.Checked = False
					btnRadioICRGBIR.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR
					btnRadioICRGB.Checked = False
					btnRadioICIR.Checked = True
					btnRadioICRGBIR.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR
					btnRadioICRGB.Checked = False
					btnRadioICIR.Checked = False
					btnRadioICRGBIR.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select
			Select Case m_objConfigData.nRadio_RGBColorDepth
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR
					btnRadioCDRColor.Checked = True
					btnRadioCDRGray.Checked = False
					btnRadioCDRBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY
					btnRadioCDRColor.Checked = False
					btnRadioCDRGray.Checked = True
					btnRadioCDRBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW
					btnRadioCDRColor.Checked = False
					btnRadioCDRGray.Checked = False
					btnRadioCDRBW.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select
			Select Case m_objConfigData.nRadio_IRColorDepth
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY
					btnRadioCDIGray.Checked = True
					btnRadioCDIBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW
					btnRadioCDIGray.Checked = False
					btnRadioCDIBW.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select

			SetIndexResolutionCombobox(m_objConfigData.nCombo_Resolution)

			udNumberOfDocuments.Minimum = 0
			udNumberOfDocuments.Maximum = 255
			udNumberOfDocuments.Value = Convert.ToDecimal(m_objConfigData.byNumeric_NumberOfDocuments)

			btnCheckSCSaveFile.Checked = m_objConfigData.bCheck_Scan_SaveFile

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			Select Case m_objConfigData.nRadio_MICRFont
				Case ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B
					btnRadioMFE13B.Checked = True
					btnRadioMFCMC7.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_MF_CMC7
					btnRadioMFE13B.Checked = False
					btnRadioMFCMC7.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select

			btnCheckMIClearSpace.Checked = m_objConfigData.bCheck_MICR_ClearSpace
			btnCheckMISaveFile.Checked = m_objConfigData.bCheck_MICR_SaveFile

			'''/////////////
			'''/ Step 8 ////
			'''/////////////

			btnCheckPIDetect.Checked = m_objConfigData.bCheck_PI_Detect
			btnCheckPICancel.Checked = m_objConfigData.bCheck_PI_Cancel
			btnCheckNODetect.Checked = m_objConfigData.bCheck_NO_Detect
			btnCheckNOCancel.Checked = m_objConfigData.bCheck_NO_Cancel
			btnCheckDFDetect.Checked = m_objConfigData.bCheck_DF_Detect
			btnCheckDFCancel.Checked = m_objConfigData.bCheck_DF_Cancel
			btnCheckBDDetect.Checked = m_objConfigData.bCheck_BD_Detect
			btnCheckBDCancel.Checked = m_objConfigData.bCheck_BD_Cancel
			btnCheckNDDetect.Checked = m_objConfigData.bCheck_ND_Detect
			btnCheckNDCancel.Checked = m_objConfigData.bCheck_ND_Cancel
			btnCheckBADetect.Checked = m_objConfigData.bCheck_BA_Detect
			btnCheckBACancel.Checked = m_objConfigData.bCheck_BA_Cancel

			cmbPIEjectPocket.SelectedIndex = m_objConfigData.nCombo_PI_EjectPocket
			cmbNOEjectPocket.SelectedIndex = m_objConfigData.nCombo_NO_EjectPocket
			cmbDFEjectPocket.SelectedIndex = m_objConfigData.nCombo_DF_EjectPocket
			cmbBDEjectPocket.SelectedIndex = m_objConfigData.nCombo_BD_EjectPocket
			cmbNDEjectPocket.SelectedIndex = m_objConfigData.nCombo_ND_EjectPocket
			cmbBAEjectPocket.SelectedIndex = m_objConfigData.nCombo_BA_EjectPocket

			'''/////////////
			'''/ Step 8 ////
			'''/////////////

			lstBarcodeType.SetItemChecked(0, m_objConfigData.bCheck_BT_SymbolCodabar)
			lstBarcodeType.SetItemChecked(1, m_objConfigData.bCheck_BT_SymbolCode128)
			lstBarcodeType.SetItemChecked(2, m_objConfigData.bCheck_BT_SymbolCode39)
			lstBarcodeType.SetItemChecked(3, m_objConfigData.bCheck_BT_SymbolITF)
			lstBarcodeType.SetItemChecked(4, m_objConfigData.bCheck_BT_SymbolEAN)
			lstBarcodeType.SetItemChecked(5, m_objConfigData.bCheck_BT_SymbolUPCA)
			lstBarcodeType.SetItemChecked(6, m_objConfigData.bCheck_BT_SymbolUPCE)
		End Sub

		Private Sub GetControlData()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			If btnRadioSMCheckPaper.Checked = True Then
				m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER
			ElseIf btnRadioSMCard.Checked = True Then
				m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD
			Else
				Debug.Assert(False)
			End If

			If btnRadioICRGB.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB
			ElseIf btnRadioICIR.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR
			ElseIf btnRadioICRGBIR.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR
			End If

			If btnRadioCDRColor.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR
			ElseIf btnRadioCDRGray.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY
			ElseIf btnRadioCDRBW.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW
			End If

			If btnRadioCDIGray.Checked = True Then
				m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY
			ElseIf btnRadioCDIBW.Checked = True Then
				m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW
			End If

			m_objConfigData.nCombo_Resolution = GetValueResolutionCombobox()

			m_objConfigData.byNumeric_NumberOfDocuments = Convert.ToByte(udNumberOfDocuments.Value)

			m_objConfigData.bCheck_Scan_SaveFile = btnCheckSCSaveFile.Checked

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			If btnRadioMFE13B.Checked = True Then
				m_objConfigData.nRadio_MICRFont = ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B
			ElseIf btnRadioMFCMC7.Checked = True Then
				m_objConfigData.nRadio_MICRFont = ConstComVal.VAL_CONFIGDLG_RADIO_MF_CMC7
			Else
				Debug.Assert(False)
			End If

			m_objConfigData.bCheck_MICR_ClearSpace = btnCheckMIClearSpace.Checked
			m_objConfigData.bCheck_MICR_SaveFile = btnCheckMISaveFile.Checked

			'''/////////////
			'''/ Step 8 ////
			'''/////////////

			m_objConfigData.bCheck_PI_Detect = btnCheckPIDetect.Checked
			m_objConfigData.bCheck_PI_Cancel = btnCheckPICancel.Checked
			m_objConfigData.nCombo_PI_EjectPocket = cmbPIEjectPocket.SelectedIndex
			m_objConfigData.bCheck_NO_Detect = btnCheckNODetect.Checked
			m_objConfigData.bCheck_NO_Cancel = btnCheckNOCancel.Checked
			m_objConfigData.nCombo_NO_EjectPocket = cmbNOEjectPocket.SelectedIndex
			m_objConfigData.bCheck_DF_Detect = btnCheckDFDetect.Checked
			m_objConfigData.bCheck_DF_Cancel = btnCheckDFCancel.Checked
			m_objConfigData.nCombo_DF_EjectPocket = cmbDFEjectPocket.SelectedIndex
			m_objConfigData.bCheck_BD_Detect = btnCheckBDDetect.Checked
			m_objConfigData.bCheck_BD_Cancel = btnCheckBDCancel.Checked
			m_objConfigData.nCombo_BD_EjectPocket = cmbBDEjectPocket.SelectedIndex
			m_objConfigData.bCheck_ND_Detect = btnCheckNDDetect.Checked
			m_objConfigData.bCheck_ND_Cancel = btnCheckNDCancel.Checked
			m_objConfigData.nCombo_ND_EjectPocket = cmbNDEjectPocket.SelectedIndex
			m_objConfigData.bCheck_BA_Detect = btnCheckBADetect.Checked
			m_objConfigData.bCheck_BA_Cancel = btnCheckBACancel.Checked
			m_objConfigData.nCombo_BA_EjectPocket = cmbBAEjectPocket.SelectedIndex

			'''/////////////
			'''/ Step 8 ////
			'''/////////////

			m_objConfigData.bCheck_BT_SymbolCodabar = lstBarcodeType.GetItemChecked(0)
			m_objConfigData.bCheck_BT_SymbolCode128 = lstBarcodeType.GetItemChecked(1)
			m_objConfigData.bCheck_BT_SymbolCode39 = lstBarcodeType.GetItemChecked(2)
			m_objConfigData.bCheck_BT_SymbolITF = lstBarcodeType.GetItemChecked(3)
			m_objConfigData.bCheck_BT_SymbolEAN = lstBarcodeType.GetItemChecked(4)
			m_objConfigData.bCheck_BT_SymbolUPCA = lstBarcodeType.GetItemChecked(5)
			m_objConfigData.bCheck_BT_SymbolUPCE = lstBarcodeType.GetItemChecked(6)
		End Sub

		Private Sub UpdateControls()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			' LightSource
			If btnRadioSMCard.Checked = True AndAlso m_objConfigData.bIsScanningCardIR1PassSupported = False Then
				btnRadioICRGBIR.Enabled = False

				If btnRadioICRGBIR.Checked = True Then
					btnRadioICIR.Checked = True
					btnRadioICRGBIR.Checked = False
				End If
			Else
				btnRadioICRGBIR.Enabled = True
			End If

			' RGB ColorDepth Color
			If btnRadioICIR.Checked = True Then
				btnRadioCDRColor.Enabled = False
			Else
				btnRadioCDRColor.Enabled = True
			End If

			' RGB ColorDepth Gray
			If btnRadioICIR.Checked = True Then
				btnRadioCDRGray.Enabled = False
			Else
				btnRadioCDRGray.Enabled = True
			End If

			' RGB ColorDepth B/W
			If btnRadioICIR.Checked = True OrElse btnRadioSMCard.Checked = True Then
				btnRadioCDRBW.Enabled = False
			Else
				btnRadioCDRBW.Enabled = True
			End If

			' IR ColorDepth Gray
			If btnRadioICRGB.Checked = True Then
				btnRadioCDIGray.Enabled = False
			Else
				btnRadioCDIGray.Enabled = True
			End If

			' IR ColorDepth B/W
			If btnRadioICRGB.Checked = True OrElse btnRadioSMCard.Checked = True Then
				btnRadioCDIBW.Enabled = False
			Else
				btnRadioCDIBW.Enabled = True
			End If

			If btnRadioCDRBW.Checked = True AndAlso btnRadioCDRGray.Enabled.Equals(True) AndAlso Not btnRadioCDRBW.Enabled.Equals(True) Then
				btnRadioCDRColor.Checked = False
				btnRadioCDRGray.Checked = True
				btnRadioCDRBW.Checked = False
			End If
			If btnRadioCDIBW.Checked = True AndAlso btnRadioCDIGray.Enabled.Equals(True) AndAlso Not btnRadioCDIBW.Enabled.Equals(True) Then
				btnRadioCDIGray.Checked = True
				btnRadioCDIBW.Checked = False
			End If

			' Updating resolution options for scanning unit
			Dim strResolution As String = cmbResolution.Text
			If btnRadioSMCheckPaper.Checked = True Then
				cmbResolution.Items.Clear()
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100)
				cmbResolution.SelectedIndex = 2
			ElseIf btnRadioSMCard.Checked = True Then
				cmbResolution.Items.Clear()
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
				cmbResolution.SelectedIndex = 1
			Else
				Debug.Assert(False)
			End If
			' restore the selection.
			Dim nIndex As Integer = cmbResolution.FindString(strResolution)
			If nIndex <> -1 Then
				cmbResolution.SelectedIndex = nIndex
			End If

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			If btnRadioSMCard.Checked = True Then
				btnRadioMFE13B.Enabled = False
				btnRadioMFCMC7.Enabled = False
				btnCheckMIClearSpace.Enabled = False
				btnCheckMISaveFile.Enabled = False
			ElseIf btnRadioSMCheckPaper.Checked = True Then
				btnRadioMFE13B.Enabled = True
				btnRadioMFCMC7.Enabled = True
				btnCheckMIClearSpace.Enabled = True
				btnCheckMISaveFile.Enabled = True
			Else
				Debug.Assert(False)
			End If

			'''/////////////
			'''/ Step 8 ////
			'''/////////////

			If btnRadioSMCard.Checked = True Then
				btnCheckPIDetect.Enabled = False
				btnCheckNODetect.Enabled = False
				btnCheckDFDetect.Enabled = False
				btnCheckBDDetect.Enabled = False
				btnCheckNDDetect.Enabled = False
				btnCheckBADetect.Enabled = False
			ElseIf btnRadioSMCheckPaper.Checked = True Then
				btnCheckPIDetect.Enabled = True
				btnCheckNODetect.Enabled = True
				btnCheckDFDetect.Enabled = True
				btnCheckBDDetect.Enabled = True
				btnCheckNDDetect.Enabled = True
				btnCheckBADetect.Enabled = True
			Else
				Debug.Assert(False)
			End If

			' Paper Insertion
			If btnCheckPIDetect.Checked = True AndAlso btnCheckPIDetect.Enabled.Equals(True) Then
				btnCheckPICancel.Enabled = True
				cmbPIEjectPocket.Enabled = True
			Else
				btnCheckPICancel.Enabled = False
				cmbPIEjectPocket.Enabled = False
			End If

			' Noise
			If btnCheckNODetect.Checked = True AndAlso btnCheckNODetect.Enabled.Equals(True) Then
				btnCheckNOCancel.Enabled = True
				cmbNOEjectPocket.Enabled = True
			Else
				btnCheckNOCancel.Enabled = False
				cmbNOEjectPocket.Enabled = False
			End If

			' Double Feed
			If btnCheckDFDetect.Checked = True AndAlso btnCheckDFDetect.Enabled.Equals(True) Then
				btnCheckDFCancel.Enabled = True
				cmbDFEjectPocket.Enabled = True
			Else
				btnCheckDFCancel.Enabled = False
				cmbDFEjectPocket.Enabled = False
			End If

			' Bad Data
			If btnCheckBDDetect.Checked = True AndAlso btnCheckBDDetect.Enabled.Equals(True) Then
				btnCheckBDCancel.Enabled = True
				cmbBDEjectPocket.Enabled = True
			Else
				btnCheckBDCancel.Enabled = False
				cmbBDEjectPocket.Enabled = False
			End If

			' No Data
			If btnCheckNDDetect.Checked = True AndAlso btnCheckNDDetect.Enabled.Equals(True) Then
				btnCheckNDCancel.Enabled = True
				cmbNDEjectPocket.Enabled = True
			Else
				btnCheckNDCancel.Enabled = False
				cmbNDEjectPocket.Enabled = False
			End If

			' Barcode
			If btnCheckBADetect.Checked = True AndAlso btnCheckBADetect.Enabled.Equals(True) Then
				btnCheckBACancel.Enabled = True
				cmbBAEjectPocket.Enabled = True
			Else
				btnCheckBACancel.Enabled = False
				cmbBAEjectPocket.Enabled = False
			End If
		End Sub

		'''/////////////
		'''/ Step 2 ////
		'''/////////////

		Private Sub btnOK_Click(sender As Object, e As EventArgs)
			GetControlData()
			Close()
		End Sub

		Private Sub btnCancel_Click(sender As Object, e As EventArgs)
			Close()
		End Sub

		Private Sub OnChangeRadioScanningMedia(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub OnChangeRadioLightSource(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		'''/////////////
		'''/ Step 8 ////
		'''/////////////

		Private Sub OnChangeCheckPaperInsertionDetect()
			UpdateControls()
		End Sub

		Private Sub OnChangeCheckNoiseDetect()
			UpdateControls()
		End Sub

		Private Sub OnChangeCheckDoubleFeedDetect()
			UpdateControls()
		End Sub

		Private Sub OnChangeCheckBadDataDetect()
			UpdateControls()
		End Sub

		Private Sub OnChangeCheckNoDataDetect()
			UpdateControls()
		End Sub

		Private Sub OnChangeCheckBarcodeDetect()
			UpdateControls()
		End Sub

		'''/////////////
		'''/ Step 8 ////
		'''/////////////

		Private Sub btnCheckPIDetect_Click(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnCheckNODetect_Click(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnCheckDFDetect_Click(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnCheckBDDetect_Click(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnCheckNDDetect_Click(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnCheckBADetect_Click(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		'''/////////////
		'''/ Step 2 ////
		'''/////////////

		Private Sub SetIndexResolutionCombobox(nResolution As Integer)
			Dim strResolution As String = ""
			Select Case nResolution
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_600600
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_600600
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_300300
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_300300
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_240240
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_240240
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_200200
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_120120
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_120120
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_100100
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_100100
					Exit Select
				Case Else
					Debug.Assert(False)
					Return
			End Select
			Dim nIndex As Integer = cmbResolution.FindString(strResolution)
			If nIndex <> -1 Then
				cmbResolution.SelectedIndex = nIndex
			Else
				cmbResolution.SelectedIndex = 0
			End If
		End Sub

		Private Function GetValueResolutionCombobox() As Integer
			Select Case cmbResolution.SelectedItem.ToString()
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_600600
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_600600
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_300300
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_300300
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_240240
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_240240
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_200200
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_120120
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_120120
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_100100
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_100100
				Case Else
					Debug.Assert(False)
					Return -1
			End Select
		End Function
	End Class
End Namespace
