Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace TMS_Sample
	Public Partial Class DeviceInfoForm
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub DeviceInfoForm_Load(sender As Object, e As EventArgs)

		End Sub

		Private Sub DeviceInfoForm_FormClosing(sender As Object, e As FormClosingEventArgs)
			If e.CloseReason = CloseReason.UserClosing Then
				Hide()
				e.Cancel = True
			End If
		End Sub

		Public Sub DisplayDeviceInfo(objDeviceInfo As CDeviceInfo)
			If objDeviceInfo Is Nothing Then
				Return
			End If

			Const  TWO_POCKET_MODEL As UInteger = &H2
			Const  SCAN_200DPM_MODEL As UInteger = &H10
			Const  SCAN_110DPM_MODEL As UInteger = &H8

			edtDIDeviceName.Text = objDeviceInfo.GetDeviceName().ToString()
			edtDIFirmwareVersion.Text = objDeviceInfo.GetFirmVersion().ToString()
			edtDIManufacture.Text = objDeviceInfo.GetManufacture().ToString()
			edtDISerialNumber.Text = objDeviceInfo.GetSerialNumber().ToString()

			If (objDeviceInfo.GetTypeIdB()(0) And TWO_POCKET_MODEL) = TWO_POCKET_MODEL Then
				edtDIPocket.Text = "2 pocket"
			Else
				edtDIPocket.Text = "1 pocket"
			End If

			If (objDeviceInfo.GetTypeIdB()(0) And SCAN_200DPM_MODEL) = SCAN_200DPM_MODEL Then
				edtDISpeed.Text = "200DPM"
			ElseIf (objDeviceInfo.GetTypeIdB()(0) And SCAN_110DPM_MODEL) = SCAN_110DPM_MODEL Then
				edtDISpeed.Text = "110DPM"
			End If
		End Sub

		Public Sub DisplayMaintenanceCounter(objMaintenanceCounter As CMaintenanceCounter)
			If objMaintenanceCounter Is Nothing Then
				Return
			End If

			DisplayIntOnEdit(edtMCScanedCheck, stMCScanedCheck, objMaintenanceCounter.GetImageScannedCheckPaper())
			DisplayIntOnEdit(edtMCScanedCard, stMCScanedCard, objMaintenanceCounter.GetImageScannedCard())
			DisplayIntOnEdit(edtMCLineFeeds, stMCLineFeeds, objMaintenanceCounter.GetLineFeeds())
			' S9000 only
			DisplayIntOnEdit(edtMCPumpOperation, stMCPumpOperation, objMaintenanceCounter.GetPumpOperation())
			DisplayIntOnEdit(edtMCMicrRead, stMCMicrRead, objMaintenanceCounter.GetMicrReads())
			DisplayIntOnEdit(edtMCHeadShotA, stMCHeadShotA, objMaintenanceCounter.GetHeadShotA())
			DisplayIntOnEdit(edtMCHeadShotB, stMCHeadShotB, objMaintenanceCounter.GetHeadShotB())
			DisplayIntOnEdit(edtMCHeadEnergization, stMCHeadEnergization, objMaintenanceCounter.GetHeadEnergization())
			' S9000 only
			DisplayIntOnEdit(edtMCAsfSendingOff, stMCAsfSendingOff, objMaintenanceCounter.GetAsfSendingOff())
			DisplayIntOnEdit(edtMCHeadLineFeeds, stMCHeadLineFeeds, objMaintenanceCounter.GetHeadLineFeeds())
			' S9000 only
			DisplayIntOnEdit(edtMCAutoCutter, stMCAutoCutter, objMaintenanceCounter.GetAutoCutter())
			' S9000 only
			DisplayIntOnEdit(edtMCHopper, stMCHopper, objMaintenanceCounter.GetHopper())
			DisplayIntOnEdit(edtMCPocketSelect, stMCPocketSelect, objMaintenanceCounter.GetPocketSelect())
			DisplayIntOnEdit(edtMCDeviceOperationTime, stMCDeviceOperationTime, objMaintenanceCounter.GetDeviceOperationTime())
		End Sub

		Private Sub DisplayIntOnEdit(edt As TextBox, st As Label, n As Integer)
			If n >= 0 Then
				' S9000
				st.Enabled = True
				edt.Enabled = True
				edt.Text = n.ToString()
			Else
				' S2000
				st.Enabled = False
				edt.Enabled = False
				edt.Text = "N/A"
			End If
		End Sub

		Private Sub btnClose_Click(sender As Object, e As EventArgs)
			Hide()
		End Sub
	End Class
End Namespace
