Imports System.Diagnostics
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace TMS_Sample
	Public Partial Class DeviceStatusForm
		Inherits Form
		' Deligates types
		Public Delegate Sub DisplayDeviceStatusType(ByRef objDeviceStatus As CDeviceStatus)
		Public Delegate Sub DisplayInkStatusType(ByRef objDeviceStatus As CInkStatus)

		' Deligates to invoke
		Public DisplayDeviceStatus As DisplayDeviceStatusType = Nothing
		Public DisplayInkStatus As DisplayInkStatusType = Nothing

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub DeviceStatusForm_Load(sender As Object, e As EventArgs)
			' Setting up deligates to invoke
			DisplayDeviceStatus = New DisplayDeviceStatusType(AddressOf DisplayDeviceStatusImpl)
			DisplayInkStatus = New DisplayInkStatusType(AddressOf DisplayInkStatusImpl)
		End Sub

		Private Sub DeviceStatusForm_FormClosing(sender As Object, e As FormClosingEventArgs)
			If e.CloseReason = CloseReason.UserClosing Then
				Hide()
				e.Cancel = True
			End If
		End Sub

		Public Sub DisplayDeviceStatusImpl(ByRef objDeviceStatus As CDeviceStatus)
			If Me.InvokeRequired Then
				Me.BeginInvoke(DisplayDeviceStatus, New Object() {objDeviceStatus})
				Return
			End If

			Debug.Assert(objDeviceStatus IsNot Nothing)
			If objDeviceStatus Is Nothing Then
				Return
			End If

			If objDeviceStatus.GetNoResponse() = True Then
				btnCheckDSNoResponse.Checked = True
				btnCheckDSOffLine.Checked = False
				btnCheckDSCoverOpen.Checked = False
				btnCheckDSWaitPaperEject.Checked = False
				btnCheckDSMechanicalErr.Checked = False
				btnCheckDSUnrecoverErr.Checked = False
				btnCheckDSPaperIntermediate.Checked = False
				btnCheckDSReceiptNearEnd.Checked = False
				' S9000 only
				btnCheckDSEjectSensorNoPaper.Checked = False
				btnCheckDSReceiptEnd.Checked = False
				' S9000 only
				btnCheckDSSlipPaperSize.Checked = False
				btnCheckDSAsfPaper.Checked = False
				btnCheckDSWaitInsert.Checked = False
				btnCheckDSMainPocketNearFull.Checked = False
				btnCheckDSSubPocketNearFull.Checked = False
			ElseIf objDeviceStatus.GetNoResponse() = False Then
				btnCheckDSNoResponse.Checked = False
				btnCheckDSOffLine.Checked = objDeviceStatus.GetOffLine()
				btnCheckDSCoverOpen.Checked = objDeviceStatus.GetCoverOpen()
				btnCheckDSWaitPaperEject.Checked = objDeviceStatus.GetWaitPaperEject()
				btnCheckDSMechanicalErr.Checked = objDeviceStatus.GetMechanicalError()
				btnCheckDSUnrecoverErr.Checked = objDeviceStatus.GetUnrecoverError()
				btnCheckDSPaperIntermediate.Checked = Not objDeviceStatus.GetPaperInsermadiate()
				btnCheckDSReceiptNearEnd.Checked = objDeviceStatus.GetReceiptNearEnd()
				' S9000 only
				btnCheckDSEjectSensorNoPaper.Checked = Not objDeviceStatus.GetEjectSensorPaper()
				btnCheckDSReceiptEnd.Checked = objDeviceStatus.GetReceiptEnd()
				' S9000 only
				btnCheckDSSlipPaperSize.Checked = Not objDeviceStatus.GetSlipPaperSize()
				btnCheckDSAsfPaper.Checked = Not objDeviceStatus.GetAsfPaper()
				btnCheckDSWaitInsert.Checked = objDeviceStatus.GetWaitInsert()
				btnCheckDSMainPocketNearFull.Checked = objDeviceStatus.GetMainPocketNearFull()
				btnCheckDSSubPocketNearFull.Checked = objDeviceStatus.GetSubPocketNearFull()
			End If
		End Sub

		Public Sub DisplayInkStatusImpl(ByRef objInkStatus As CInkStatus)
			If Me.InvokeRequired Then
				Me.BeginInvoke(DisplayInkStatus, New Object() {objInkStatus})
				Return
			End If

			Debug.Assert(objInkStatus IsNot Nothing)
			If objInkStatus Is Nothing Then
				Return
			End If

			btnCheckISInkNearEnd.Checked = objInkStatus.GetInkNearEnd()
			btnCheckISInkEnd.Checked = objInkStatus.GetInkEnd()
			btnCheckISInkNoCartridge.Checked = objInkStatus.GetInkNoCartridge()
			btnCheckISInkCleaning.Checked = objInkStatus.GetInkCleaning()
		End Sub

		Private Sub btnClose_Click(sender As Object, e As EventArgs)
			Hide()
		End Sub
	End Class
End Namespace
